# Copyright (C) 2015 The Meme Factory, Inc.  http://www.meme.com/
#
#    This file is part of Babase.
#
#    Babase is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
#
# Karl O. Pinc <kop@meme.com>

MIN_VERSION_INFO = 3, 3

import sys, os
if not sys.version_info >= MIN_VERSION_INFO:
    exit("Python {}.{}+ is required.".format(*MIN_VERSION_INFO))

from setuptools import setup, find_packages

def get_version(*path):
    with open(os.path.join(os.path.dirname(__file__), *path)) as fileobj:
        for line in fileobj:
            tupl = line.split('=')
            if len(tupl) > 1:
                name, val = tupl[:2]
                if name.rstrip() == '__version__':
                    val =  val.strip()
                    delim = val[0]
                    if val.startswith(delim * 3):
                        delim = delim * 3
                    return val.split(delim)[1]
    raise RunTimeError('No version number found')

__version__ = get_version('babase/_version.py')
setup(
    name             = 'Babase',
    version          = __version__,
    maintainer       = 'Karl O. Pinc',
    maintainer_email = 'kop@meme.com',
    description      = 'Python programs for Babase',
    license          = 'GPLv3 or later',
    packages         = find_packages(),
    scripts          = ['babase/babase_postgres_restore',
                        'babase/chado/chado-vcf-load',
                        'babase/chado/chado-funcgen-load',
                        ],
    entry_points     = {'console_scripts':
                            ['chado-stock-load = '
                             'babase.chado.chado_stock_load:main',
                             'chado-funcgen-dump = '
                             'babase.chado.chado_funcgen_dump:main',
                            ]
                       }
#['babase',
#                'babase.lib',
#                'babase.babase_postgres_restore',
#                'babase.chado.chado-vcf-load']
)
