* Copyright (C) 2005-2008, Karl O. Pinc
*
*    This file is part of Babase.
*
*    Babase is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
*
* Program to dump all the babase foxpro files into text files.
*
* Karl O. Pinc
*
* Feb 7, 2005
*
* As we want the full year, may as well fix the external
* representation here.


* ACTS
select act, descr, class, chartob(old) ;
  from acts to file dump/acts ;
  noconsole plain ;
  order by act

* MSTATS
select mstatus, descr;
  from mstats to file dump/mstats ;
  noconsole plain;
  order by mstatus
  
* BSTATS
select bstatus, descr ;
  from bstats to file dump/bstats ;
  noconsole plain;
  order by bstatus

* STATUSES
select status, descr ;
  from statuses to file dump/statuses ;
  noconsole plain;
  order by status

* DCAUSES
select dcause, descr ;
  from dcauses to file dump/dcauses ;
  noconsole plain;
  order by dcause

* RNKTYPES
select rnktype, descr, query ;
  from rnktypes to file dump/rnktypes ;
  noconsole plain;
  order by rnktype

* NCODES
select code, descr ;
  from ncodes to file dump/ncodes ;
  noconsole plain;
  order by code

* GROUPS
select gid, name, znf(from_group), permanent, supergroup, ;
       isodate(start), isodate(end), lettercode ;
  noconsole plain;
  from groups to file dump/groups ;
  order by gid

* CENSUS
select cenid, isodate(date), sname, grp, status, pgbool(cen) ;
  from census to file dump/census ;
  noconsole plain;
  order by cenid

* DEMOG
select cenid, reference, comment ;
  from demog to file dump/demog ;
  noconsole plain;
  order by cenid

* BIOGRAPH.MATDATE
select sname, isodate(matured), mungmstat(mstatus) ;
  from biograph to file dump/maturedates ;
  noconsole plain;
  where year(matured) != 0 ;
  order by sname

* BIOGRAPH.RANKED
select sname, isodate(ranked), 'O' ;
  from biograph to file dump/rankdates ;
  noconsole plain;
  where year(ranked) != 0 ;
  order by sname

* BIOGRAPH.CONSORTED
select sname, isodate(consorted) ;
  from biograph to file dump/consortdates ;
  noconsole plain;
  where year(consorted) != 0 ;
  order by sname

* BIOGRAPH.DISPERSED
select sname, isodate(dispersed) ;
  from biograph to file dump/dispersedates ;
  noconsole plain;
  where year(dispersed) != 0 ;
  order by sname

* MEMBERS
select sname, isodate(date), grp, origin, interp ;
  from members to file dump/members ;
  noconsole plain;
  order by sname, date, origin, grp
  
* SEXSKINS
* select cid, isodate(date), size ;
*  from sexskins to file dump/sexskins ;
*   noconsole plain;
*   order by cid, date

select cycles.sname, isodate(sexskins.date), sexskins.size ;
 from sexskins, cycles to file dump/sexskins ;
  where cycles.cid = sexskins.cid ;
  noconsole plain;
  order by cycles.sname, sexskins.date
  
* PREGS
*select pid, parity, conceive, znf(resume) ;
*  from pregs to file dump/pregs ;
*  noconsole plain;
*  order by pid


 select pregs.pid ;
      , pregs.parity ;
      , isodate(ccyc.ddate) as conceive ;
      , isodate(rcyc.tdate) as resume ;
   from pregs ;
        left outer join cycles as rcyc on (rcyc.cid = pregs.resume) ;
        join cycles as ccyc on (ccyc.cid = pregs.conceive) ;
   to file dump/pregs ;
   noconsole plain;
   order by pid


* select pregs.pid ;
*      , pregs.parity ;
*      , isodate(ccyc.ddate) as conceive ;
*      , isodate(rcyc.tdate) as resume ;
*   from pregs, cycles as ccyc, ;
*        cycles as rcyc ;
*   to file dump/pregsresume ;
*   where ccyc.cid = pregs.conceive ;
*         and rcyc.cid = pregs.resume ;
*   noconsole plain;
*   order by pid
* 
* select pregs.pid ;
*      , pregs.parity ;
*      , isodate(cycles.ddate) as conceive ;
*   from pregs, cycles ;
*   to file dump/pregsnoresume ;
*   where cycles.cid = pregs.conceive ;
*         and pregs.resume = 0 ;
*   noconsole plain;
*   order by pid

* CYCLES
* See dump_as_text file for info on what's going on here.
* select ;
*    cid ;
*  , sname ;
*  , seq ;
*  , isodate(mdate) ;
*  , isodate(emdate) ;
*  , isodate(lmdate) ;
*  , isodate(tdate) ;
*  , isodate(etdate) ;
*  , isodate(ltdate) ;
*  , isodate(ddate) ;
*  , isodate(eddate) ;
*  , isodate(lddate) ;
*   from cycles to file dump/cycles ;
*   noconsole plain;
*   order by sname, seq

* CYCLES
select sname, seq ;
  from cycles to file dump/cycles ;
  noconsole plain;
  order by sname, seq

* Mdates
select sname, seq, isodate(mdate), isodate(emdate), isodate(lmdate) ;
  from cycles to file dump/mdatesseq ;
  where mdate != {} ;
  noconsole plain;
  order by sname, seq

* Tdates
select sname, seq, isodate(tdate), isodate(etdate), isodate(ltdate) ;
  from cycles to file dump/tdatesseq ;
  where tdate != {} ;
  noconsole plain;
  order by sname, seq

* Ddates
select sname, seq, isodate(ddate), isodate(eddate), isodate(lddate) ;
  from cycles to file dump/ddatesseq ;
  where ddate != {} ;
  noconsole plain;
  order by sname, seq

* Now do the ones without sequence numbers.

* Mdates
select sname, isodate(mdate), isodate(emdate), isodate(lmdate) ;
  from cycles to file dump/mdates ;
  where mdate != {} ;
  noconsole plain;
  order by sname, seq

* Tdates
select sname, isodate(tdate), isodate(etdate), isodate(ltdate) ;
  from cycles to file dump/tdates ;
  where tdate != {} ;
  noconsole plain;
  order by sname, seq

* Ddates
select sname, isodate(ddate), isodate(eddate), isodate(lddate) ;
  from cycles to file dump/ddates ;
  where ddate != {} ;
  noconsole plain;
  order by sname, seq

* BIOGRAPH
select ;
  sname ;
 ,name ;
 ,pid ;
 ,isodate(birth) ;
 ,znf(bstatus) ;
 ,sex ;
 ,matgrp ;
 ,isodate(statdate) ;
 ,znf(status) ;
 ,znf(dcause) ;
  from biograph to file dump/biograph ;
  noconsole plain;
  order by sname, pid

* RANKS
select grp, sname, rnkdate, rnktype, rank ;
  from ranks to file dump/ranks ;
  noconsole plain;
  where rnktype != 'ALL' ;
  order by grp, sname, rnkdate, rnktype
  
* SAMPLES
select sid, isodate(date), observer, grp, sname, mins, miniss, setupid, psionid ;
  from samples to file dump/samples ;
  noconsole plain;
  order by sid
  
* INTERACT
select sid, '*', iid, act, isodate(date), start, stop ;
  from interact to file dump/interact ;
  noconsole plain;
  order by iid
  
* PARTS
select iid, sname, role ;
  from parts to file dump/parts ;
  noconsole plain;
  order by iid, sname, role
  
* JPSAMPS
select jpid, sid, activity, posture, time, foodcode ;
  from jpsamps to file dump/jpsamps ;
  noconsole plain;
  order by jpid
  
* JPNEIGHBORS
select jpid, sname, code, unkid ;
  from jpneighbors to file dump/jpneighbors ;
  noconsole plain;
  order by jpid, sname, unkid, code
  
* FPSAMPS
select fpid, sid, activity, posture, kidcontact, kidsuckle, time, foodcode ;
  from fpsamps to file dump/fpsamps ;
  noconsole plain;
  order by fpid

* FPNEIGHBORS
select fpid, sname, code, unkid ;
  from fpneighbors to file dump/fpneighbors ;
  noconsole plain;
  order by fpid, sname, unkid, code
  
* ADLIBS
select sid, time, txt ;
  from adlibs to file dump/adlibs ;
  noconsole plain;
  order by sid


FUNCTION znf
PARAMETER n

if n = 0 then
  return 0
else
  return n
endif


FUNCTION mungmstat
PARAMETER n

if n = "" then
  return "O"
else
  return n
endif
  
  
FUNCTION isodate
PARAMETER d
if ISNULL(d) then
  return "0-00-00"
else
  * Foxpro is so broken we'll get rid of the 0-00-00 in shell!
  return STR(YEAR(d)) + "-" + PADL(LTRIM(STR(MONTH(d))), 2, "0") + "-" + PADL(LTRIM(STR(DAY(d))), 2, "0")
endif
  

function pgbool
parameter b
if b then
  return "t"
else
  return "f"
endif

function chartob
parameter c
if upper(c) = "Y" then
  return "t"
else
  return "f"
endif


