# Copyright (C) 2013 The Meme Factory, Inc., http://www.meme.com/
# Copyright (C) 2004, 2005, 2008, 2011 Karl O. Pinc, <kop@meme.com>
#
#    This file is part of Babase.
#
#    Babase is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
#
# Default variable assignments for database creation related makefiles.
#
# Karl O. Pinc <kop@meme.com>

# You probably want to override the database with BABASE_DB=babase
#  on the make command line.
ifeq ($(strip $(BABASE_DB)),)
  export BABASE_DB := babase_copy
endif
# Use sockets to talk with database server.
# The Unix socket is no longer reserved for the Unix postgres user and root.
export SERVERHOST := /tmp
export ADMINUSER := babase_admin

# For invoking psql everywhere.
PSQL_ARGS = --tuples-only -q \
           -h $(SERVERHOST) -U $(ADMINUSER) -d $(BABASE_DB)
