dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2006, 2008, Karl O. Pinc <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Re-assign all sexskins associated with a cycle to the correct cycle.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl
dnl m4 includes
include(`copyright.m4')
include(`constants.m4')
include(`macros.m4')
dnl

CREATE OR REPLACE FUNCTION _reassign_sexskins(this_cid cycles.cid%TYPE)
  RETURNS void
  LANGUAGE plpgsql
  SECURITY DEFINER
  bb_function_set_search_path
  AS $$
  -- Re-assign all sexskins associated with a cycle to the correct cycle.
  --
  -- GPL_notice(`  --', `2006, 2008', `Karl O. Pinc <kop@meme.com>')
  --
  -- Syntax: _re_assign_sexskins(this_cid)
  --
  -- Arguments:
  --  this_cid  Cid of the cycle containing the sexskins to re-assign.
  --
  -- Remarks:
  --  Called from triggers.
  --
  -- Bugs:

  BEGIN
    -- Don't have to do much because the sexskins BEFORE update trigger
    -- automatically re-assigns sexskins to cycles.
    UPDATE sexskins
      SET cid = this_cid
      WHERE cid = this_cid;

  RETURN;
  END;
$$;
grant_func_priv(`_reassign_sexskins(this_cid cycles.cid%TYPE)')
