dnl Copyright (C) 2015 The Meme Factory, Inc.  http://www.meme.com/
dnl Copyright (C) 2004, 2008, 2009, 2011, Karl O. Pinc
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Remove all functions from the database
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl Bugs:
dnl  The abstraction of the datatypes that uses column names does not
dnl really work.  Combinations of errors and changing table definition
dnl can leave an old function lying around.
dnl
dnl m4 includes
include(`copyright.m4')
include(`types.m4')

--
-- Remove all functions from the database so
-- we can re-create it with our creation scripts.
--

--
-- Functions
--

--
-- General purpose
--
DROP FUNCTION julian(DATE);
DROP FUNCTION julian(TIMESTAMP);

DROP FUNCTION julian_to(INT);

DROP FUNCTION spm(TIME);
-- DROP FUNCTION spm(TIME(0));
DROP FUNCTION spm(INTERVAL);
DROP FUNCTION spm(TIMESTAMP);

DROP FUNCTION spm_to(INT);
DROP FUNCTION spm_to(DOUBLE PRECISION);

DROP FUNCTION rnkdate(DATE);

DROP FUNCTION date_mod(TEXT, TIMESTAMP);
DROP FUNCTION date_mod(TEXT, INTERVAL);

DROP FUNCTION hydroyear(DATE);
DROP FUNCTION hydroyear(TIMESTAMP);
DROP FUNCTION hydroyear(TEXT);

DROP FUNCTION season(DATE);
DROP FUNCTION season(TIMESTAMP);
DROP FUNCTION season(TEXT);

--
-- Geocoordinate related
--
DROP FUNCTION bb_makepoint(DOUBLE PRECISION, DOUBLE PRECISION);

--
-- Repstats and Cycstats related.
--
DROP FUNCTION _compute_cycstats(cycles.sname%TYPE
                         , cycles.cid%TYPE
                         , cycles.tdate%TYPE
                         , cycles.ddate%TYPE
                         , cycles.cid%TYPE
                         , cycles.tdate%TYPE) CASCADE;
DROP FUNCTION _compute_repstats(cycles.sname%TYPE
                         , cycles.cid%TYPE
                         , cycles.tdate%TYPE
                         , cycles.ddate%TYPE
                         , cycles.cid%TYPE
                         , cycles.tdate%TYPE) CASCADE;
DROP FUNCTION _make_repstats(date
                             , date
                             , cycles.sname%TYPE
                             , repstats.state%TYPE
                             , repstats.cids%TYPE
                             , repstats.cide%TYPE
                             , repstats.pid%TYPE) CASCADE;
DROP FUNCTION _make_cycstats(date
                             , date
                             , cycles.sname%TYPE
                             , repstats.state%TYPE
                             , repstats.cids%TYPE
                             , repstats.cide%TYPE) CASCADE;

DROP FUNCTION rebuild_repstats(repstats.sname%TYPE) CASCADE;
DROP FUNCTION rebuild_all_repstats() CASCADE;
DROP FUNCTION rebuild_cycstats(cycstats.sname%TYPE) CASCADE;
DROP FUNCTION rebuild_all_cycstats() CASCADE;

--
-- Members releated
--
DROP FUNCTION rebuild_members(members.sname%TYPE) CASCADE;
DROP FUNCTION rebuild_all_members() CASCADE;

DROP FUNCTION _interp_delete(  this_sname  members.sname%TYPE
                             , this_date   date
                             , this_status census.status%TYPE);
DROP FUNCTION _interp_insert(  this_sname  members.sname%TYPE
                             , this_date   date
                             , this_group  census.grp%TYPE
                             , this_status census.status%TYPE);
DROP FUNCTION _interp_about_date(  this_sname  members.sname%TYPE
                                 , this_date   date
                                 , this_group  census.grp%TYPE
                                 , this_status census.status%TYPE);
DROP FUNCTION _interpish_about_date(  this_sname  members.sname%TYPE
                                    , this_date   date
                                    , this_group  census.grp%TYPE
                                    , this_status census.status%TYPE);
DROP FUNCTION _interp(  this_sname      census.sname%TYPE
                      , alive           BOOLEAN
                      , early_bound     census.date%TYPE
                      , late_bound      census.date%TYPE
                      , early_group     census.grp%TYPE
                      , late_group      census.grp%TYPE
                      , birth_interp    BOOLEAN
                      , statdate_interp BOOLEAN
                      , interp_left     BOOLEAN
                      , interp_right    BOOLEAN);
DROP FUNCTION _interp_midpoint(date, date);

DROP FUNCTION delete_census(char(3), date, date);

-- cycgapdays related
DROP FUNCTION rebuild_cycgapdays(cycgapdays.sname%TYPE) CASCADE;
DROP FUNCTION rebuild_all_cycgapdays() CASCADE;
DROP FUNCTION _cycgapdays_insert(cycgaps) CASCADE;
DROP FUNCTION _cycgapdays_delete(cycgaps) CASCADE;


-- Automatic Mdates
DROP FUNCTION _add_autom(cycles.sname%TYPE
                         , cycpoints);
DROP FUNCTION _remove_autom(cycles.sname%TYPE
                            , cycpoints.date%TYPE
                            , cycpoints.cpid%TYPE);
-- Updating of sexskins (used in triggers)
DROP FUNCTION _reassign_sexskins(cycles.cid%TYPE);

DROP FUNCTION rebuild_automdates(cycles.sname%TYPE) CASCADE;
DROP FUNCTION rebuild_all_automdates() CASCADE;

-- Cycles Seq and Series
DROP FUNCTION _recalc_seq_series(cycgaps.sname%TYPE
                               , cycpoints.date%TYPE
                               , cycles.cid%TYPE) CASCADE;
DROP FUNCTION rebuild_cycles(cycles.sname%TYPE) CASCADE;
DROP FUNCTION rebuild_all_cycles() CASCADE;

-- Sexskins
DROP FUNCTION rebuild_sexskins(cycles.sname%TYPE) CASCADE;
DROP FUNCTION rebuild_all_sexskins() CASCADE;

-- Groups (and Ranks and Members and Census)
DROP FUNCTION supergroup(b_grp_type, DATE);

-- Chado
DROP FUNCTION chado_analysis_delete(INT);
DROP FUNCTION chado_analysis_delete(VARCHAR(255));

-- Conversion related.  Don;t know that this really belongs here.
DROP FUNCTION _install_cycgaps() CASCADE;
DROP FUNCTION _install_cycgaps_pregs(TEXT) CASCADE;

-- The warning system
include(`destroywarningfunctions.m4')
