dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2010, Karl O. Pinc <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Return code for the season in which a given date falls.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl
dnl m4 includes
include(`copyright.m4')
include(`constants.m4')
include(`macros.m4')
dnl
dnl Make plpg/sql function that returns the hydrological year as an integer
dnl given different input data types.
dnl
dnl Syntax: _make_season_func(datatype, typecast)
dnl
dnl Input:
dnl   datatype  The postgres data type the function takes as input.
dnl   typecast  The "::foo" typecast to cast datatype to a date,
dnl             or nothing if no typecase is needed.
dnl
dnl Variables required:
dnl Restrictions:
changequote({,})
define({_make_season_func},{

CREATE OR REPLACE FUNCTION season(this_date $1)
  RETURNS CHAR(1)
  LANGUAGE plpgsql
  IMMUTABLE
  bb_function_set_search_path
  AS $$

  -- Return the code for the season in which a given date falls.
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')
  --
  -- Syntax:  season(date)
  --
  -- Input:
  --   date  The date in question.  A $1.
  --
  -- Returns:
  --  Code for the season.
  --
  -- Remarks:

  DECLARE
    m DOUBLE PRECISION := EXTRACT(MONTH FROM this_date$2);

  BEGIN
    ifelse(eval(bb_ds_first_month < bb_ws_first_month), 1, dnl
    IF m >= bb_ws_first_month 
       OR m < bb_ds_first_month THEN
      RETURN 'bb_wetter_season';
    END IF;
    RETURN 'bb_dry_season';
    ,dnl
    IF m >= bb_ds_first_month THEN
       OR m < bb_ws_first_month THEN
      RETURN 'bb_dry_season';
    END IF;
    RETURN 'bb_wetter_season';
    )dnl
  END;
$$;

grant_everybody_func_priv(`season($1)')
})
changequote(`,')dnl

-- Make the functions.
_make_season_func(`DATE', `')
_make_season_func(`TIMESTAMP', `')
_make_season_func(`TEXT', `::TIMESTAMP')
