dnl Copyright (C) 2017 Jake Gordon <jacob.gordon@duke.edu>
dnl Copyright (C) 2011, 2012, 2014, 2015 The Meme Factory, Inc.
dnl   http://www.meme.com/
dnl Copyright (C) 2004, 2008-2011 Karl O. Pinc  <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Constant data values hardcoded into the system.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl Bugs:
dnl  This file is processed by Makefiles (with m4toconstants)
dnl to produce xml entities for use in the documentation and the
dnl view definitions.  This processing is simplistic and requires
dnl defines be a single line and arguments be quoted.
dnl
dnl  When python constants are created the default is to quote the value.
dnl To use the value in python without quotes the m4 define must be closed
dnl with ")dnl noquote".  So, the default is a python string datatype
dnl and non-strings must be marked.
dnl 
dnl
changequote([{[,]}])dnl m4 foolery so includes include only once.
dnl                     Once the macro is in the text, change the quotes back
ifdef([{[_constants.m4]}], [{[changequote(`,')]}], [{[dnl
changequote(`,')dnl
dnl
dnl Standard test for having already included the file.
define(`_constants.m4')dnl
dnl
dnl Turn output off.  This file produces no output.
divert(-1)

dnl
dnl Name of the live database
dnl
define(`bb_live_db', `babase')

dnl syslog facility at which utility programs log
define(`bb_syslog_facility', `local6')

dnl
dnl Constants for command line programs.
dnl

dnl The various ways to say 'false'.
dnl (These must all be written here in lower case.)
define(`bb_false_false', `false')
define(`bb_false_f', `f')
define(`bb_false_n', `n')
define(`bb_false_no', `no')
define(`bb_false_0', `0')
define(`bb_false_emptystring', `')

dnl The various pg transaction isolation levels
define(`bb_til_read_committed', `read_committed')
define(`bb_til_repeatable_read', `repeatable_read')
define(`bb_til_serializable', `serializable')
define(`bb_til_database_default', `database_default')

dnl Various vcf related constants

dnl The number of "fixed" columns in the vcf column headings.
dnl (The rest are identifiers of analyized genotypes.)
define(`bb_vcf_last_fixed_col', `8')dnl noquote
dnl The delimiter used by vcf files.
define(`bb_vcf_delim', `\t')

dnl
dnl The abrp-genomics-update-testdir program.
dnl

dnl The directory where the links live
define(`bb_mnt_abrp_genomics', `/mnt/abrp_genomics')

dnl The user to use on the remote system
define(`bb_receive_abrp_genomics_schema', `abrpdbloader')

dnl
dnl The chado-funcgen-dump program.
dnl

dnl Environment variable for defaults
define(`bb_chado_funcgen_dump_envvar', `CHADO_FUNCGEN_DUMP')

dnl Prefix put in front of anonymized stock column headings.
define(`bb_cfd_anon_stock_prefix', `STK_')

dnl Default of --column-number-cv
define(`bb_cfd_column_number_cv_default', `null')

dnl Default of --column-number-term
define(`bb_cfd_column_number_term_default', `column_number')

dnl Default of --file-cv
define(`bb_cfd_file_cv_default', `null')

dnl Default of --file-term
define(`bb_cfd_file_term_default', `pathname')

dnl  The fixed parameters used by the web interface.

define(`bb_cfd_web_nd_experiment_cv', `babase_chado_terms')
define(`bb_cfd_web_nd_experiment_term', `column_in_analysis')
define(`bb_cfd_web_column_cv', `babase_chado_terms')
define(`bb_cfd_web_column_term', `column_in_analysis')
define(`bb_cfd_web_column_number_cv', `babase_chado_terms')
define(`bb_cfd_web_column_number_term', `column_number')
define(`bb_cfd_web_file_cv', `babase_chado_terms')
define(`bb_cfd_web_file_term', `pathname')


dnl
dnl The chado-funcgen-load program.
dnl

dnl Environment variable for defaults.
define(`bb_chado_funcgen_load_envvar', `CHADO_FUNCGEN_LOAD')

dnl Default of --file-cv
define(`bb_cfl_file_cv_default', `null')

dnl Default of --file-term
define(`bb_cfl_file_term_default', `pathname')

dnl Default of --column-number-cv
define(`bb_cfl_column_number_cv_default', `null')

dnl Default of --column-number-term
define(`bb_cfl_column_number_term_default', `column_number')

dnl
dnl The chado-stock-load program.
dnl

dnl Environment variable for defaults
define(`bb_chado_stock_load_envvar', `CHADO_STOCK_LOAD')

dnl The db which usually records the stock.  The identifiers in this
dnl db can appear as the row headings in the first column of the
dnl uploaded file.  When the first column contains this value
dnl special processing is done.
define(`bb_csl_special_col1_db', `did')

dnl The string which can appear in column 3, the id column,
dnl of the uploaded file meaning "no id".  The empty string
dnl also has this meaning.
define(`bb_csl_missing_unique_id', `NULL')

dnl The string which can appear in a property column
dnl meaning that NULL should be stored in the db.
define(`bb_csl_no_prop_value', `NULL')

dnl The column headings the program knows about.
dnl The delimiter on which column headings are parsed.
define(`bb_csl_hdg_delim', `:')
dnl Complete column heading containing the column number
define(`bb_csl_column_number_hdg', `column_number')
dnl The prefix of the primary type column.
define(`bb_csl_primarytype_prefix_hdg', `primarytype')
dnl The prefix of the type columns
define(`bb_csl_type_prefix_hdg', `type')
dnl The prefix of the property columns.
define(`bb_csl_prop_prefix_hdg', `prop')

dnl The lowest column number allowed.
define(`bb_csl_min_col_num', `2')dnl noquote

dnl
dnl The chado_vcf_load program
dnl

dnl Environment variable for defaults
define(`bb_chado_vcf_load_envvar', `CHADO_VCF_LOAD')

dnl Character used in vcf files when there is no data.
define(`bb_vcf_empty', `.')

dnl The suffix to remove when constructing analysis.name from
dnl file name.  (Must be lower case.)
define(`bb_cvl_vcf', `vcf')

dnl Default for --source-feature-cv
define(`bb_cvl_source_feature_cv_default', `sequence')

dnl Default for --source-feature-term
define(`bb_cvl_source_feature_term_default', `chromosome')

dnl Default for --source-feature-relationship-cv
define(`bb_cvl_source_feature_relationship_cv_default', `relationship')

dnl Default for --source-feature-relationship-term
define(`bb_cvl_source_feature_relationship_term_default', `is_a')

dnl Default for --reference-base-feature-cv
define(`bb_cvl_reference_base_feature_cv_default', `sequence')

dnl Default for --alternate-base-term
dnl (If you change this, change the SO id number written into the docs.)
define(`bb_cvl_alternate_base_term_default', `polymorphic_sequence_variant')

dnl Default for --feature-relationship-cv
define(`bb_cvl_feature_relationship_cv_default', `relationship')

dnl Default for --reference-base-feature-relationship-term
define(`bb_cvl_reference_base_feature_relationship_term_default', `part_of')

dnl Default for --genotype-reference-relationship-term
define(`bb_cvl_genotype_reference_relationship_term_default', `instance_of')

dnl Default for --file-cv
define(`bb_cvl_file_cv_default', `null')

dnl Default of --file-term
define(`bb_cvl_file_term_default', `pathname')

dnl
dnl The chado_analysis_delete() sql function
dnl

dnl Values which identify uploaded genotypes
define(`bb_cad_sample_id_trans_cv', `babase_chado_terms')
define(`bb_cad_sample_id_trans_term', `vcf_column_source')

dnl Values which identify the reference baboon genotype
define(`bb_cad_feature_db_name', `unique_baboons')
define(`bb_cad_reference_base_feature_dbxref_accession', `reference_baboon')


dnl
dnl Constants for chado data
dnl

dnl For all the property table Rank columns.
define(`bb_chado_rank_singleton', `0')dnl noquote

dnl CVTERM.Is_Obsolete
define(`bb_cvterm_not_obsolete', `0')dnl noquote

dnl CVTERM.Is_Relationshiptype
define(`bb_cvterm_not_relationshiptype', `0')dnl noquote

dnl FEATURE.Strand
define(`bb_strand_no_direction', `0')dnl noquote
define(`bb_strand_forward_direction', `+1')dnl noquote
define(`bb_strand_backward_direction', `-1')dnl noquote

dnl FEATURELOC.Phase
dnl (Names are stupid since I'm ignorant of what phase is.)
dnl (Maybe it's activation, initialtion, elognation, termination?)
define(`bb_featureloc_phase_0', `0')dnl noquote
define(`bb_featureloc_phase_1', `1')dnl noquote
define(`bb_featureloc_phase_2', `2')dnl noquote

dnl FEATURELOC.Locgroup
define(`bb_default_locgroup', `0')dnl noquote

dnl FEATURELOC.Rank

dnl For BLAST/HSP hits this is the qeury, for sequence varients
dnl this is the baseline.  In babase anlysis this is the
dnl location on the reference genome (the baseline).
define(`bb_featureloc_rank_default', `0')dnl noquote

dnl For BLAST/HSP hits this is the subject, for sequence varients
dnl this is the mutant or compared location.  In babase analysis
dnl this is the location of an analyzed individual on the reference
dnl genome.
define(`bb_featureloc_rank_alt1', `1')dnl noquote

dnl
dnl Constants for data types.
dnl

dnl The length of OBSERVER_ROLES.Role.
define(`bb_observer_roles_len', `75')

dnl The length of BODYPARTS.BPID
define(`bb_bodyparts_bpid_len', `8')

dnl
dnl Constants for data.
dnl

dnl Value returneed by the GPS units in the Header column when
dnl the waypoint button is pressed.
define(`bb_waypoint_button', `Waypoint')

dnl Feet to meters conversion factor.
define(`bb_feet_to_meters', `0.3048')

dnl Generic percentage range
define(`bb_min_percent', `0')
define(`bb_max_percent', `100')

dnl Generic probablity range.
define(`bb_almost_never', `0')
define(`bb_almost_surely', `1')

dnl The number of days in the year for computation
dnl of age in years with decimal digits of precision.
dnl (Use of this is limited.  Using calendar age is preferred.)
define(`bb_daysinyear', `365.25')

dnl The hydrological year.
define(`bb_hy_first_month', `11')dnl calendar month number
define(`bb_hy_first_day', `1')

dnl The seasons
define(`bb_dry_season', `D')
define(`bb_wetter_season', `W')
define(`bb_ds_first_month', `6')dnl calendar month number
define(`bb_ws_first_month', `11')dnl calendar month number

dnl When the observation starts and stops every day.
define(`bb_day_early_start', `04:00')dnl earliest start of the work day
define(`bb_day_start', `05:00')
define(`bb_day_departures_end', `14:30')dnl latest usual departure from camp
define(`bb_day_early_end', `19:00')
define(`bb_day_end', `20:00')

dnl The X and Y coordinates of the "soft" (warning) boundries of the
dnl study area.  Anything inside this, inclusive, is ok.
define(`bb_min_ok_x_coord', `277000.0')
define(`bb_max_ok_x_coord', `311100.0')
define(`bb_min_ok_y_coord', `9689200.0')
define(`bb_max_ok_y_coord', `9709500.0')
dnl The postgis representaiton of the "soft" boundries of the study area.
define(`bb_ok_study_area', `POLYGON((bb_min_ok_x_coord bb_min_ok_y_coord, bb_max_ok_x_coord bb_min_ok_y_coord, bb_max_ok_x_coord bb_max_ok_y_coord, bb_min_ok_x_coord bb_max_ok_y_coord, bb_min_ok_x_coord bb_min_ok_y_coord))')

dnl The X and Y coordinates of the "hard" (error) boundries of the study area.
define(`bb_min_x_coord', `42300.0')
define(`bb_max_x_coord', `651000.0')
define(`bb_min_y_coord', `9497000.0')
define(`bb_max_y_coord', `9894500.0')
dnl The postgis representation of the "hard" boundries of the study area.
define(`bb_hard_study_area', `POLYGON((bb_min_x_coord bb_min_y_coord, bb_max_x_coord bb_min_y_coord, bb_max_x_coord bb_max_y_coord, bb_min_x_coord bb_max_y_coord, bb_min_x_coord bb_min_y_coord))')
dnl The PostGIS SPATIAL_REF_SYS.SRID value for Amboseli.
dnl (The EPSG coordinate reference system id.)
define(`bb_amboseli_srid', `32737')

dnl SWERB altitude limits
define(`bb_altitude_min', `0')
define(`bb_altitude_max', `10000')

dnl groups.grp
define(`bb_unk_grp', `9.0')

dnl biograph.sex
define(`bb_male', `M')
define(`bb_female', `F')
define(`bb_unk_sex', `U')

dnl biograph.status
define(`bb_alive', `0')

dnl biograph.dcause
define(`bb_no_dcause', `0')

dnl biograph.dcausenatureconfidence and dcauseagentconfidence
define(`bb_no_dcauseconfidence', `0')

dnl biograph.entrytype
define(`bb_entrytype_birth', `B')

dnl unknown indvidual for neighbors, and other point sample data
define(`bb_unidentified_sname', `998')

dnl sexskins.size
define(`bb_min_skin', `0')
define(`bb_max_skin', `20')
define(`bb_frac_skin', `0.5')

dnl acts.class (Not interact.act!)
define(`bb_agonism', `A')
define(`bb_grooming', `G')
define(`bb_mounts', `M')
define(`bb_consortship', `C')
define(`bb_ejaculation', `E')
define(`bb_approach', `P')
define(`bb_request_to_groom', `R')

dnl parts.role and mpi_parts.role
define(`bb_actor', `R')
define(`bb_actee', `E')

dnl members.origin
dnl census.status (except bb_interpolated never shows up in census)
define(`bb_census', `C')
define(`bb_demog', `D')
define(`bb_interpolated', `I')
define(`bb_absent', `A')
define(`bb_manual', `M')
dnl bb_manual_no_interp used only in constraint definition.
define(`bb_manual_no_interp', `N')
define(`bb_S', `S')
define(`bb_E', `E')
define(`bb_F', `F')
define(`bb_G', `G')
define(`bb_B', `B')
define(`bb_L', `L')
define(`bb_T', `T')
define(`bb_R', `R')

dnl pregs
dnl Pregnancy length for warning
dnl (Get warned if a pregnancy is longer than this many days)
define(`bb_preg_len_warn', `191')

dnl pregs.parity
define(`bb_unkfirst_parity', `101')
dnl Modulo to test parity
dnl (Should be bb_unkfirst_parity minus 1)
define(`bb_unkmod_parity', `100')

dnl cycgaps.code
define(`bb_cg_start', `S')
define(`bb_cg_end',   `E')
define(`bb_cg_point', `P')

dnl cycgaps.state
define(`bb_cg_menses',       `M')
define(`bb_cg_swelling',     `S')
define(`bb_cg_ovulating',    `O')
define(`bb_cg_deturgesence', `D')
define(`bb_cg_pregnant',     `P')
define(`bb_cg_lactating',    `L')

dnl cycpoints.source
define(`bb_data', `D')
define(`bb_auto', `A')
define(`bb_estimated', `E')

dnl cycpoints.code
define(`bb_menses', `M')
define(`bb_turgesence', `T')
define(`bb_deturgesence', `D')
define(`bb_bleeding', `B')

dnl repstats.state
define(`bb_pregnant', `P')
define(`bb_cycling', `C')
define(`bb_lactating', `L')

dnl cycstats.state
define(`bb_swelling', `S')
define(`bb_ovulating', `O')
dnl Also uses bb_menses
dnl Also uses bb_deturgesence



dnl samples

dnl Types for samples.stype
define(`bb_juvenile_point', `J')
define(`bb_female_point', `F')
define(`bb_max_mins',`10')

dnl point_data

dnl Activity codes for points.activity

dnl The feeding activity
define(`bb_feed_activity', `F')

dnl fpoints

dnl Kidcontact codes for kidcontact
define(`bb_kidcon_away', `A')
define(`bb_kidcon_ventral', `V')
define(`bb_kidcon_dorsal', `D')
define(`bb_kidcon_other', `O')
define(`bb_kidcon_none', `N')

dnl Kidsuckle codes for kidsuckle
define(`bb_kidsuck_suckling', `S')
define(`bb_kidsuck_notsuckling', `N')
define(`bb_kidsuck_unknown', `U')

dnl Ncodes.Nsex values
define(`bb_nc_any', `A')
define(`bb_nc_male', `M')
define(`bb_nc_opposite', `O')

dnl mstatuses (maturedates and rankdates)
define(`bb_on', `O')
define(`bb_by', `B')dnl not used outside of the documentation

dnl rankdates (applies to consortdates as well)
dnl Rank date must be on or after 5 years of age.
define(`bb_min_rankdate_age', `5')
dnl Rank date must be before 12 years of age,
dnl but only when rank attinment is observed.
dnl (And is a warning for consortdates.)
define(`bb_max_rankdate_age', `12')
dnl The minimum and maximum year of the rankdate (inclusive).
define(`bb_min_rnkdate_year', `1940')
define(`bb_max_rnkdate_year', `2040')
dnl Unranked individuals over 8.5 y/o should
dnl elicit a warning.
define(`bb_warn_rankdate_age', `8.5')

dnl allmiscs

dnl The delimiter in the Txt column.
define(`bb_almtxt_delim', `,')

dnl The Txt codes.
define(`bb_almtxt_consortship', `C')
define(`bb_almtxt_unknown', `U')
define(`bb_almtxt_other', `O')

dnl
dnl dad_data
dnl
define(`bb_min_loci_excl', `0')
define(`bb_max_loci_excl', `40')
define(`bb_max_pdads_considered', `50')

dnl
dnl Views
dnl

dnl potential_dads
define(`bb_pdad_adult', `A')
define(`bb_pdad_subadult', `S')
define(`bb_pdad_other', `O')
dnl Minimum age in days to be a potential dad.  (6 years)
define(`bb_min_dad_age', `2192')

dnl swerb
define(`bb_xysource_quad', `quad')
define(`bb_xysource_gps', `gps')

dnl
dnl Computational constants
dnl

dnl Interpolation.  Number of days, not counting census date,
dnl the individual is presumed to stay in the group where
dnl observed.
define(`bb_interpolation_max', `14')

dnl Date interact.date grooming dates become per-day
dnl rather than per-month.
define(`bb_grooming_transition', `2006-07-01')

dnl Age limit before which males cannot have mounts, consortships,
dnl or ejaculations.
define(`bb_min_male_mce_age', `4 years')

dnl 5 day ovulation period
dnl Used for computations of sexual cycle state
define(`bb_ovulation_len', `5')

dnl Automatic Mdates come, at most, 13 days after the preceeding Ddate.
define(`bb_autom_interval', `13')

dnl sexskin turgesence warning limit before Tdate
define(`bb_normal_max_skin_before_t', `1')
dnl sexskins turgesenece limit before Tdate
define(`bb_max_skin_before_t', `5')

dnl sexskins turgesence warning limit on the Mdate
define(`bb_normal_skin_on_m', `0')
dnl sexskins turgesence limit before Mdate
define(`bb_max_skin_before_m', `0')
dnl sexskins turgesence limit on Mdate
define(`bb_max_skin_on_m', `1')
dnl execpt that the turgesence can be 5 if the Mdate is a Tdate
define(`bb_max_skin_on_mt', `5')

dnl maximum and minimum age (in days) for maturity
dnl maximum is strictly less then
dnl minimum is greater or equal to (at least)
define(`bb_max_maturity_age', `2798')
define(`bb_min_maturity_age', `1016')

dnl bodyparts

dnl bodyparts.bodyside
define(`bb_leftside', `L')
define(`bb_rightside', `R')

dnl bodyparts.innerouter
define(`bb_inner', `I')
define(`bb_outer', `O')

dnl dartings
dnl maximum interval between darting time and downtime
define(`bb_downtime_max_delay', `1 hour')
dnl maximium interval between downtime (and darttime) and pickuptime
define(`bb_pickuptime_max_delay', `90 minutes')
dnl warning if there's more time than this between downtime and pickuptime
define(`bb_pickuptime_warning_delay', `30 minutes')
dnl date on or after which females should have a vaginal swab
define(`bb_vaginalswab_start', `2006-01-01')

dnl anesths
dnl maximum interval between darting anesthetic administration
define(`bb_max_knockout_interval', `150 minutes')
dnl maximum anesthetic amount
define(`bb_max_anamount', `1.0')

dnl crownrumps
define(`bb_min_crlength', `10')
define(`bb_max_crlength', `99.9')

dnl chests
define(`bb_min_chcircum', `25')
define(`bb_max_chcircum', `99.9')

dnl bodytemps
define(`bb_min_btemp', `25')
define(`bb_max_btemp', `45')

dnl dphys
define(`bb_min_pulse', `0')
define(`bb_min_respiration', `0')

dnl dart_sample_types and dsamples
define(`bb_dst_bloodunspec', `1')
define(`bb_dst_bloodpaxgene', `2')
define(`bb_dst_bloodpurptop', `3')
define(`bb_dst_bloodsep', `4')
define(`bb_dst_bloodcpt', `5')
define(`bb_dst_bloodtruculture', `6')
define(`bb_dst_bloodsmear', `7')
define(`bb_dst_hairunspec', `8')
define(`bb_dst_hairlength', `9')
define(`bb_dst_haircuzn', `10')
define(`bb_dst_3mouth', `11')
define(`bb_dst_leftmandmold', `12')
define(`bb_dst_leftmaxmold', `13')
define(`bb_dst_lm1m2', `14')
define(`bb_dst_skinpunch', `15')
define(`bb_dst_vagswab', `16')
define(`bb_dst_cervswab', `17')
define(`bb_dst_bloodtc', `18')
define(`bb_dst_skintc', `19')
define(`bb_dst_fecal_formalin', `20')
define(`bb_dst_vaginal_ph', `21')
define(`bb_dst_palm_swab', `22')
define(`bb_dst_tongue_swab', `23')
define(`bb_dst_tooth_plaque_swab', `24')
define(`bb_dst_vagswab_microbiome', `25')
define(`bb_dst_glans_penis_swab', `26')
define(`bb_dst_fecal_microbiome', `27')
define(`bb_dst_nostrils_swab', `28')
define(`bb_dst_skin_behind_ear_swab', `29')
define(`bb_dst_skin_inside_elbow_swab', `30')

dnl humeresus
define(`bb_min_hulength', `10')
define(`bb_max_hulength', `35')

dnl pcvs
define(`bb_min_pcv', `1')
define(`bb_max_pcv', `99')

dnl The TSTATES tooth state that means the tooth is missing.
define(`bb_tooth_missing', `M')

dnl Left and right side codes
define(`bb_left', `L')
define(`bb_right', `R')

dnl The CONTEXT_TYPES row that means no context.
define(`bb_no_context', `N')
dnl The CONTEXT_TYPES row that means consortship.
define(`bb_consort_context', `C')

dnl MPIACTS.MPIAct values.
define(`bb_active_help', `AH')
define(`bb_passive_help', `PH')

dnl The MPIACTS.Kind values.
define(`bb_help_given_mact', `H')
define(`bb_help_request_mact', `R')
define(`bb_agonism_mact', `A')
define(`bb_other_mact', `O')

dnl Darting related stuff.

dnl testes.testside
define(`bb_lefttestes', `L')
define(`bb_righttestes', `R')

dnl Age at which testicles reach adult size
define(`bb_adult_testes_age', `7 years')

dnl testes_diam.testlength
define(`bb_min_diam_testlength', `15')
define(`bb_min_adult_diam_testlength', `40')
define(`bb_max_diam_testlength', `75')

dnl testes_diam.testwidth
define(`bb_min_diam_testwidth', `10')
define(`bb_min_adult_diam_testwidth', `25')
define(`bb_max_diam_testwidth', `51')

dnl testes_arc.testlength
define(`bb_min_arc_testlength', `15')
define(`bb_min_adult_arc_testlength', `15')
define(`bb_max_arc_testlength', `140')

dnl testes_arc.testwidth
define(`bb_min_arc_testwidth', `10')
define(`bb_min_adult_arc_testwidth', `10')
define(`bb_max_arc_testwidth', `95')

dnl ticks
define(`bb_min_tickcount', `0')
define(`bb_max_tickcount', `250')

dnl tickstatuses
define(`bb_tickstatus_zero', `0')
define(`bb_tickstatus_ticks', `1')

dnl ulnas
define(`bb_min_ullength', `10')
define(`bb_max_ullength', `35')

dnl teeth.tooth
define(`bb_tooth_rum3', `rum3')
define(`bb_tooth_rum2', `rum2')
define(`bb_tooth_rum1', `rum1')
define(`bb_tooth_rup2', `rup2')
define(`bb_tooth_rup1', `rup1')
define(`bb_tooth_ruc', `ruc')
define(`bb_tooth_rui2', `rui2')
define(`bb_tooth_rui1', `rui1')
define(`bb_tooth_lui1', `lui1')
define(`bb_tooth_lui2', `lui2')
define(`bb_tooth_luc', `luc')
define(`bb_tooth_lup1', `lup1')
define(`bb_tooth_lup2', `lup2')
define(`bb_tooth_lum1', `lum1')
define(`bb_tooth_lum2', `lum2')
define(`bb_tooth_lum3', `lum3')
define(`bb_tooth_llm3', `llm3')
define(`bb_tooth_llm2', `llm2')
define(`bb_tooth_llm1', `llm1')
define(`bb_tooth_llp2', `llp2')
define(`bb_tooth_llp1', `llp1')
define(`bb_tooth_llc', `llc')
define(`bb_tooth_lli2', `lli2')
define(`bb_tooth_lli1', `lli1')
define(`bb_tooth_rli1', `rli1')
define(`bb_tooth_rli2', `rli2')
define(`bb_tooth_rlc', `rlc')
define(`bb_tooth_rlp1', `rlp1')
define(`bb_tooth_rlp2', `rlp2')
define(`bb_tooth_rlm1', `rlm1')
define(`bb_tooth_rlm2', `rlm2')
define(`bb_tooth_rlm3', `rlm3')
define(`bb_tooth_drum2', `drum2')
define(`bb_tooth_drum1', `drum1')
define(`bb_tooth_druc', `druc')
define(`bb_tooth_drui2', `drui2')
define(`bb_tooth_drui1', `drui1')
define(`bb_tooth_dlui1', `dlui1')
define(`bb_tooth_dlui2', `dlui2')
define(`bb_tooth_dluc', `dluc')
define(`bb_tooth_dlum1', `dlum1')
define(`bb_tooth_dlum2', `dlum2')
define(`bb_tooth_dllm2', `dllm2')
define(`bb_tooth_dllm1', `dllm1')
define(`bb_tooth_dllc', `dllc')
define(`bb_tooth_dlli2', `dlli2')
define(`bb_tooth_dlli1', `dlli1')
define(`bb_tooth_drli1', `drli1')
define(`bb_tooth_drli2', `drli2')
define(`bb_tooth_drlc', `drlc')
define(`bb_tooth_drlm1', `drlm1')
define(`bb_tooth_drlm2', `drlm2')

dnl toothcodes.toothsite
define(`bb_toothsite_1', `1')
define(`bb_toothsite_2', `2')
define(`bb_toothsite_3', `3')
define(`bb_toothsite_4', `4')
define(`bb_toothsite_5', `5')
define(`bb_toothsite_6', `6')
define(`bb_toothsite_7', `7')
define(`bb_toothsite_8', `8')
define(`bb_toothsite_9', `9')
define(`bb_toothsite_10', `10')
define(`bb_toothsite_11', `11')
define(`bb_toothsite_12', `12')
define(`bb_toothsite_13', `13')
define(`bb_toothsite_14', `14')
define(`bb_toothsite_15', `15')
define(`bb_toothsite_16', `16')
define(`bb_toothsite_17', `17')
define(`bb_toothsite_18', `18')
define(`bb_toothsite_19', `19')
define(`bb_toothsite_20', `20')
define(`bb_toothsite_21', `21')
define(`bb_toothsite_22', `22')
define(`bb_toothsite_23', `23')
define(`bb_toothsite_24', `24')
define(`bb_toothsite_25', `25')
define(`bb_toothsite_26', `26')
define(`bb_toothsite_27', `27')
define(`bb_toothsite_28', `28')
define(`bb_toothsite_29', `29')
define(`bb_toothsite_30', `30')
define(`bb_toothsite_31', `31')
define(`bb_toothsite_32', `32')

dnl raingauges
define(`bb_min_rain', `0')
define(`bb_max_rain', `200.0')

dnl tempmins
define(`bb_min_tempmin', `-5')
define(`bb_max_tempmin', `35')

dnl tempmaxs
define(`bb_min_tempmax', `10')
define(`bb_max_tempmax', `50')

dnl weatherhawk
define(`bb_timestamp_precision', `hour')
define(`bb_min_batvolt', `10.00')
define(`bb_max_batvolt', `14.00')
define(`bb_min_relhumidity', `0.0')
define(`bb_max_relhumidity', `100.0')
dnl winddir -- the weatherhawk is ugly,
dnl these are inclusive even though 0 == 360.
define(`bb_min_winddir', `0.0')
define(`bb_max_winddir', `360.0')
define(`bb_min_windspeed_km_hr', `0')
define(`bb_max_windspeed_km_hr', `30')
define(`bb_min_windspeed_m_s', `0.0')
define(`bb_max_windspeed_m_s', `15.0')
define(`bb_min_temp', `-10.0')
define(`bb_max_temp', `50.0')
define(`bb_min_solar', `0.0')
define(`bb_max_solar', `2000.0')
define(`bb_min_barom', `85.0')
define(`bb_max_barom', `95.0')
define(`bb_min_yearlyrain', `0')

dnl dad_software
define(`bb_dad_software_id_len', `10')

dnl data_structures
define(`bb_known_data_structure', `1')

dnl SWERB date limits (inclusive)
define(`bb_swerb_start', `1981-11-01')
define(`bb_quad_end', `1994-09-30')
define(`bb_gps_start', `1993-09-01')

dnl The date that altitude readings went to sub-meter
dnl accuracy.  (On this date tenth's of a meter were recorded.)
dnl This is also the date that observers began manually entering
dnl information in each waypoint, the Garmincode.
dnl Obviously, this is the date that new GPS units were introduced
dnl but this symbol name is as good as any other so....
define(`bb_subm_alt_date', `2004-01-01')

dnl SWERB accuracy/pdop readings
define(`bb_earliest_pdop', `1993-09-01')
define(`bb_latest_pdop', `2001-01-31')
define(`bb_earliest_accuracy', `2001-02-01')

define(`bb_pdop_min', `0')
define(`bb_pdop_max', `50')

define(`bb_accuracy_min', `0')
define(`bb_accuracy_max', `15')

dnl SWERB Event types.
define(`bb_swerb_begin', `B')
define(`bb_swerb_end', `E')
define(`bb_swerb_obs', `H')  dnl half hourly/hourly observation
define(`bb_swerb_water', `W')
define(`bb_swerb_ogrp', `O') dnl other group/lone animal observation

dnl Amount of time the gps timestamp (time of
dnl button press) is allowed to preceed the operator entered time value.
dnl How far ahead of the purported time is the observer allowed to record
dnl data?
define(`bb_swerb_entry_anticipation', `5 minutes')

dnl Amount of time the gps timestamp (time of button press)
dnl is allowed to follow the operator entered time value.
dnl How far after the purported observation time is the observer
dnl allowed to record data?
define(`bb_swerb_entry_delay', `15 minutes')

dnl Like bb_swerb_entry_delay, but a new constant specifically
dnl for water hole entries, because they can feasibly have a 
dnl longer delay.
define(`bb_swerb_wh_entry_delay', `30 minutes')

dnl SWERB.OGDistance number of digits
define(`bb_swerb_ogdistance_len', `3')

dnl ADCODES.ADCode values
dnl (Used by the SWERB_UPLOAD view.)
define(`bb_swerb_ascent_code', `A')
define(`bb_swerb_descent_code', `D')
define(`bb_swerb_notad_code', `N')

dnl ADCODES.ADN values
define(`bb_swerb_notad', `N')
define(`bb_swerb_ascent', `A')
define(`bb_swerb_descent', `D')

dnl The unknown grove on SWERB_GWS
define(`bb_swerb_unk_grove', `UNK')

dnl SWERB_GWS types (PLACE_TYPES.type)
define(`bb_swerb_gws_grove', `G')
define(`bb_swerb_gws_water', `W')

dnl Maximim characters that can be entered into a GPS unit when a waypoint
dnl is taken.
define(`bb_garmincode_len', `10')

dnl gps_units
define(`bb_gpsu_pdop', `PDOP')
define(`bb_gpsu_accuracy', `accuracy')

dnl swerb_loc_confs.conf special values
define(`bb_swerb_certain', `C')
define(`bb_swerb_probable', `P')

dnl Lone individuals
dnl
dnl The gid associated with lone individuals.
define(`bb_alone_grp', `10.0')
dnl
dnl The maximum time prior to recorded dispersedate a male can
dnl be sighted in swerb as a lone male, lest there be a warning.
define(`bb_lonemale_lax_time', `60 days')

dnl SWERB_UPLOAD expected data format.
dnl
dnl The character that begins the departure lines.
define(`bb_swerb_departure_char', `D')
dnl
dnl The character that's used to preface grove codes when the grove
dnl is only a probable sleeping grove.
define(`bb_swerb_probable_char', `P')
dnl
dnl The length of the time encoding the operators enter.
define(`bb_swerb_time_len', `4')
dnl
dnl The codes which precede sleeping grove times
define(`bb_swerb_mdt', `MDT')
define(`bb_swerb_mat', `MAT')

dnl swerb_time_sources.source special values
define(`bb_gps_time_source', `G')
define(`bb_norecord', `NR')

dnl
dnl The warning system.
dnl
include(`warningconstants.m4')

dnl Turn output back on
divert`'dnl
dnl
dnl
]}])dnl End of ifdef over the whole file.
