dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2006, 2008, Karl O. Pinc
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl Macros that are used by multiple subdirectories.
dnl
dnl
changequote([{[,]}])dnl m4 foolery so includes include only once.
dnl                     Once the macro is in the text, change the quotes back
ifdef([{[_sexskinmacros.m4]}], [{[changequote(`,')]}], [{[dnl
changequote(`,')dnl
dnl
dnl Standard test for having already included the file.
define(`_sexskinmacros.m4')dnl
dnl
dnl
dnl Discard any output.  Copyright and edit warning is all that's output.
divert(-1)

dnl m4 includes
include(`constants.m4')


dnl Plpgsql fragment for finding a cid to which a sexskin should belong.
dnl
dnl Syntax: _find_sexskin_cid(sexskin_row, new_cid)
dnl
dnl Arguments:
dnl    sexskin_row  A record or row type variable containing the
dnl                 sexskin to re-assign.
dnl    new_cid   Result value: Must be a cycles.cid%TYPE variable
dnl
dnl Side Effects:
dnl   Sets new_cid to the cid the sexskin should have.
dnl   Raises an exception if the sexskin can't be assigned to a cycle.
dnl
dnl Variables required:
dnl
dnl Restrictions:
changequote({,})
define({_find_sexskin_cid}, {
      --
      -- Use the latest Mdate, Tdate, or Ddate on or before the sexskin's
      -- date.  So long as there's not a gap.
      --
      SELECT INTO $2 cycpoints.cid
        FROM cycles, cycpoints
        WHERE cycles.sname = this_sname
              AND cycpoints.cid = cycles.cid
              -- AND cycpoints.code <> 'bb_bleeding'
              AND cycpoints.date <= $1.date
              AND NOT EXISTS (SELECT 1
                                FROM cycgapdays
                                WHERE cycgapdays.sname = this_sname
                                      AND cycgapdays.date < $1.date
                                      AND cycgapdays.date > cycpoints.date)
        ORDER BY cycpoints.date DESC
        LIMIT 1;

      IF NOT FOUND THEN
        --
        -- Fallback to using the earliest Tdate, or Ddate after the sexskin's
        -- date.  So long as there's not a gap or an intervening Mdate.
        --
        DECLARE
          test_code cycpoints.code%TYPE;

        BEGIN
          SELECT INTO $2,       test_code
                  cycpoints.cid, cycpoints.code
            FROM cycles, cycpoints
            WHERE cycles.sname = this_sname
                  AND cycpoints.cid = cycles.cid
                  -- AND cycpoints.code <> 'bb_bleeding'
                  AND cycpoints.date >= $1.date
                  AND NOT EXISTS (SELECT 1
                                    FROM cycgapdays
                                    WHERE cycgapdays.sname = this_sname
                                          AND cycgapdays.date > $1.date
                                          AND cycgapdays.date < cycpoints.date)
            ORDER BY cycpoints.date
            LIMIT 1;

          IF NOT FOUND OR test_code = 'bb_menses' THEN
            -- No way to assign a cycle.
            RAISE EXCEPTION 'Sxid %: Cid %: %: There is no sexual cycle (CYCLES) to which this row can be assigned'
                          , $1.sxid
                          , $1.cid
                          , $1.date;
            RETURN NULL;
          END IF;
        END;
      END IF;
})
changequote(`,')

dnl Turn output back on
divert`'dnl
]}])dnl End of ifdef over the whole file.
