dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2004, 2005, 2008, 2010, Karl O. Pinc <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl

--
-- consortdates
--
SELECT 'consortdates' AS table;

SELECT 'consortdates_func' AS function;
CREATE FUNCTION consortdates_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  -- Function for consortdates insert and update triggers
  --
  -- GPL_notice(`  --', `2004, 2005, 2008, 2010', `Karl O. Pinc <kop@meme.com>')

  BEGIN
  -- consorted date must be at least 5 years after the birthdate.
  check_age_ge_years(`CONSORTDATES', `Consorted', `bb_min_rankdate_age')

  -- consorted must be after an existing sexual maturity date.
  -- (The constraints enforce having a sexual maturity date.)
  check_gt(`CONSORTDATES', `Consorted', `MATUREDATES', `Matured')

  -- consorted must be on or after entrydate
  check_entrydate(`CONSORTDATES', `Consorted')

  -- consorted must be on or before statdate
  check_statdate(`CONSORTDATES', `Consorted')

  RETURN NULL;
  END;
$$;

SELECT 'consortdates_trigger' AS trigger;
CREATE TRIGGER consortdates_trigger
  AFTER INSERT OR UPDATE
  ON consortdates FOR EACH ROW
  EXECUTE PROCEDURE consortdates_func();
