dnl Copyright (C) 2014, 2017 Jake Gordon <jacob.gordon@duke.edu>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl    Jake Gordon <jacob.gordon@duke.edu>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl

--
-- dart_sample_cats
--
SELECT 'dart_sample_cats' AS table;

SELECT 'dart_sample_cats_func' AS function;
CREATE FUNCTION dart_sample_cats_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for dart_sample_cats insert and update triggers
  --
  -- GPL_notice(`  --', `2014, 2017', `Jake Gordon, <jacob.gordon@duke.edu>')

  IF TG_OP = 'UPDATE' THEN
    cannot_change(`DART_SAMPLE_CATS', `Ds_cat')
  END IF;

  RETURN NULL;
  END;
$$;

SELECT 'dart_sample_cats_trigger' AS trigger;
CREATE TRIGGER dart_sample_cats_trigger
  AFTER UPDATE
  ON dart_sample_cats FOR EACH ROW
  EXECUTE PROCEDURE dart_sample_cats_func();