dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2010, 2011, Karl O. Pinc <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`macros.m4')dnl

--  
-- dphys
--
SELECT 'dphys' AS table;

SELECT 'dphys_update_func' AS function;
CREATE FUNCTION dphys_update_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for dphys update trigger
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')

  cannot_change(`DPHYS', `Dphysid')
  cannot_change(`DPHYS', `Dartid')

  RETURN NULL;
  END;
$$;


SELECT 'dphys_update_trigger' AS trigger;
CREATE TRIGGER dphys_update_trigger
  AFTER UPDATE
  ON dphys FOR EACH ROW
  EXECUTE PROCEDURE dphys_update_func();
