dnl Copyright (C) 2016 Jake Gordon <jacob.gordon@duke.edu>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl
dnl
--
-- Entrytypes
--
SELECT 'entrytypes' AS table;

SELECT 'entrytypes_func' AS function;
CREATE FUNCTION entrytypes_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for entrytypes insert and update triggers
  --
  -- GPL_notice(`  --', `2016', `Jake Gordon, <jacob.gordon@duke.edu>')

  IF TG_OP = 'UPDATE' THEN
    --Cannot change the "birth" entrytype
    restrict_change(`ENTRYTYPES', `Entrytype', bb_entrytype_birth)
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'entrytypes_delete_func' AS function;
CREATE FUNCTION entrytypes_delete_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  -- Function for entrytypes delete trigger
  --
  -- GPL_notice(`  --', `2016', `Jake Gordon, <jacob.gordon@duke.edu>')

  DECLARE

  BEGIN

  restrict_delete(`ENTRYTYPES', `Entrytype', bb_entrytype_birth)

  RETURN NULL;
  END;
$$;

SELECT 'entrytypes_trigger' AS trigger;
CREATE TRIGGER entrytypes_trigger
  AFTER INSERT OR UPDATE
  ON entrytypes FOR EACH ROW
  EXECUTE PROCEDURE entrytypes_func();

SELECT 'entrytypes_delete_trigger' AS trigger;
CREATE TRIGGER entrytypes_delete_trigger
  AFTER DELETE
  ON entrytypes FOR EACH ROW
  EXECUTE PROCEDURE entrytypes_delete_func();