dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2004, 2008, Karl O. Pinc <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl

--  
-- fpoints
--
SELECT 'fpoints' AS table;

SELECT 'fpoints_func' AS function;
CREATE FUNCTION fpoints_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for fpoints insert and update triggers
  --
  -- GPL_notice(`  --', `2004, 2008', `Karl O. Pinc <kop@meme.com>')

  -- Make sure that fpoints are present only for female point
  -- samples.
  PERFORM 1
    FROM samples, points
    WHERE points.pntid = NEW.pntid
          AND samples.sid = points.sid
          AND stype <> 'bb_female_point'
    LIMIT 1;
  IF FOUND THEN
    RAISE EXCEPTION 'Pntid %: FPOINTS must be associated with a SAMPLES.Stype of bb_female_point'
                    , NEW.pntid;
    RETURN NULL;
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'fpoints_trigger' AS trigger;
CREATE TRIGGER fpoints_trigger
  AFTER INSERT OR UPDATE
  ON fpoints FOR EACH ROW
  EXECUTE PROCEDURE fpoints_func();
