dnl Copyright (C) 2012, 2013, 2015 The Meme Factory, Inc., http://www.meme.com/
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl


dnl plpgsql fragment for BLAH
dnl
dnl Syntax: BLAH(ARG)
dnl
dnl ARG   description
dnl
changequote({,})
define({BLAH},{
})dnl
changequote(`,')dnl

--  
-- integrity_queries
--
SELECT 'integrity_queries' AS table;

SELECT 'integrity_queries_update_func' AS function;
CREATE FUNCTION integrity_queries_update_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for integrity_queries update triggers
  --
  -- GPL_notice(`  --', `2015', `The Meme Factory, Inc., http://www.meme.com/')

  cannot_change(`INTEGRITY_QUERIES', `IQName')

  IF OLD.error <> NEW.error AND NEW.error THEN
    PERFORM 1
      FROM integrity_warnings
      WHERE integrity_warnings.iqname = NEW.iqname
            AND integrity_warnings.resolved IS NOT NULL;
    IF FOUND THEN
      RAISE EXCEPTION integrity_constraint_violation USING
            MESSAGE = 'Error on UPDATE of INTEGRITY_QUERIES'
          , DETAIL = 'Key (IQName) = (' || NEW.iqname
                     || '): Value (Error) = (' || NEW.error
                     || '): Cannot make into an error when there are already'
                     || ' INTEGRITY_WARNINGS rows with a TRUE Resolved value';
      RETURN NULL;
    END IF;
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'integrity_queries_update_trigger' AS trigger;
CREATE TRIGGER integrity_queries_update_trigger
  AFTER UPDATE
  ON integrity_queries FOR EACH ROW
  EXECUTE PROCEDURE integrity_queries_update_func();
