dnl Copyright (C) 2012, 2013, 2015 The Meme Factory, Inc., http://www.meme.com/
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl


dnl plpgsql fragment for BLAH
dnl
dnl Syntax: BLAH(ARG)
dnl
dnl ARG   description
dnl
changequote({,})
define({BLAH},{
})dnl
changequote(`,')dnl

--  
-- integrity_warnings
--
SELECT 'integrity_warnings' AS table;

SELECT 'integrity_warnings_func' AS function;
CREATE FUNCTION integrity_warnings_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for integrity_warnings insert and update triggers
  --
  -- GPL_notice(`  --', `2015', `The Meme Factory, Inc., http://www.meme.com/')

  IF TG_OP = 'UPDATE' THEN
    cannot_change(`INTEGRITY_WARNINGS', `IWID')
    restrict_all_change(`INTEGRITY_WARNINGS', `Warning_Id')
    restrict_all_change(`INTEGRITY_WARNINGS', `Warning_Message')
  END IF;

  -- Errors are not allowed to be resolved.
  IF NEW.resolved IS NOT NULL THEN
    PERFORM 1
      FROM integrity_queries
      WHERE integrity_queries.iqname = NEW.iqname
            AND integrity_queries.error;
    IF FOUND THEN
      RAISE EXCEPTION integrity_constraint_violation USING
            MESSAGE = 'Error on ' || TG_OP || ' of INTEGRITY_QUERIES'
          , DETAIL = 'Key (IWID) = (' || NEW.iwid
                     || '): Value (IQName) = (' || NEW.iqname
                     || '): Value (WARNING_ID) = (' || NEW.warning_id
                     || '): Value (Resolved) = (' || NEW.resolved
                     || '): The INTEGRITY_QUERY ('
                     || NEW.iqname
                     || ') produces errors, these may not be marked resolved';
      RETURN NULL;
    END IF;
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'integrity_warnings_trigger' AS trigger;
CREATE TRIGGER integrity_warnings_trigger
  AFTER INSERT OR UPDATE
  ON integrity_warnings FOR EACH ROW
  EXECUTE PROCEDURE integrity_warnings_func();
