dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2005, 2008, 2009, Karl O. Pinc <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl

--  
-- mstatuses
--
SELECT 'mstatuses' AS table;

SELECT 'mstatuses_func' AS function;
CREATE FUNCTION mstatuses_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for mstatuses insert and update triggers
  --
  -- GPL_notice(`  --', `2005, 2008, 2009', `Karl O. Pinc <kop@meme.com>')

  IF TG_OP = 'UPDATE' THEN
    -- Cannot change the on code.
    restrict_change(`MSTATUSES', `Mstatus', bb_on)
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'mstatuses_delete_func' AS function;
CREATE FUNCTION mstatuses_delete_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  -- Function for mstatuses delete trigger
  --
  -- GPL_notice(`  --', `2005, 2008, 2009', `Karl O. Pinc <kop@meme.com>')

  DECLARE

  BEGIN

  restrict_delete(`MSTATUSES', `Mstatus', bb_alive)

  RETURN NULL;
  END;
$$;


SELECT 'mstatuses_trigger' AS trigger;
CREATE TRIGGER mstatuses_trigger
  AFTER INSERT OR UPDATE
  ON mstatuses FOR EACH ROW
  EXECUTE PROCEDURE mstatuses_func();

SELECT 'mstatuses_delete_trigger' AS trigger;
CREATE TRIGGER mstatuses_delete_trigger
  AFTER DELETE
  ON mstatuses FOR EACH ROW
  EXECUTE PROCEDURE mstatuses_delete_func();
