dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl


dnl plpgsql fragment for BLAH
dnl
dnl Syntax: BLAH(ARG)
dnl
dnl ARG   description
dnl
changequote({,})
define({BLAH},{
})dnl
changequote(`,')dnl

--  
-- place_types
--
SELECT 'place_types' AS table;

SELECT 'place_types_func' AS function;
CREATE FUNCTION place_types_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for place_types insert and update triggers
  --
  -- GPL_notice(`  --', `2012', `The Meme Factory, Inc., http://www.meme.com/')

  IF TG_OP = 'UPDATE' THEN
    -- Cannot change the values with special meaning.
    restrict_change(`PLACE_TYPES', `Place', bb_swerb_gws_water)
    restrict_change(`PLACE_TYPES', `Place', bb_swerb_gws_grove)
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'place_types_delete_func' AS function;
CREATE FUNCTION place_types_delete_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  -- Function for place_types delete trigger
  --
  -- GPL_notice(`  --', `2012', `The Meme Factory, Inc., http://www.meme.com/')

  DECLARE

  BEGIN
  -- Cannot delete special values.
  restrict_delete(`PLACE_TYPES', `Place', bb_swerb_gws_water)
  restrict_delete(`PLACE_TYPES', `Place', bb_swerb_gws_grove)

  RETURN NULL;
  END;
$$;


SELECT 'place_types_trigger' AS trigger;
CREATE TRIGGER place_types_trigger
  AFTER INSERT OR UPDATE
  ON place_types FOR EACH ROW
  EXECUTE PROCEDURE place_types_func();

SELECT 'place_types_delete_trigger' AS trigger;
CREATE TRIGGER place_types_delete_trigger
  AFTER DELETE
  ON place_types FOR EACH ROW
  EXECUTE PROCEDURE place_types_delete_func();
