dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2006, 2008, Karl O. Pinc <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl

--  
-- postures
--
SELECT 'postures' AS table;

SELECT 'postures_func' AS function;
CREATE FUNCTION postures_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for postures insert and update triggers
  --
  -- GPL_notice(`  --', `2006, 2008', `Karl O. Pinc <kop@meme.com>')

  IF TG_OP = 'UPDATE' THEN
    -- Can't change a posture used in female point samples to a
    -- juvenile-only posture.
    IF NOT(OLD.juvonly) AND NEW.juvonly <> OLD.juvonly THEN
      PERFORM 1
        FROM samples, point_data
        WHERE point_data.posture = NEW.posture
              AND samples.sid = point_data.sid
              AND samples.stype = 'bb_female_point'
        LIMIT 1;
      IF FOUND THEN
        RAISE EXCEPTION '%: Cannot change a posture already used in female point samples to be juvenile-only'
                        , NEW.posture;
        RETURN NULL;
      END IF;
    END IF;
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'postures_trigger' AS trigger;
CREATE TRIGGER postures_trigger
  AFTER INSERT OR UPDATE
  ON postures FOR EACH ROW
  EXECUTE PROCEDURE postures_func();
