dnl Copyright (C) 2017 Jake Gordon, <jacob.gordon@duke.edu>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Jake Gordon
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl

--
-- swerb_loc_confidences
--
SELECT 'swerb_loc_confidences' AS table;

SELECT 'swerb_loc_confidences_func' AS function;
CREATE FUNCTION swerb_loc_confidences_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for swerb_loc_confidences insert and update triggers
  --
  -- GPL_notice(`  --', `2017', `Jake Gordon, <jacob.gordon@duke.edu>')

  RETURN NULL;
  END;
$$;


SELECT 'swerb_loc_confidences_delete_func' AS function;
CREATE FUNCTION swerb_loc_confidences_delete_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  SECURITY DEFINER
  bb_function_set_search_path
  AS $$
  -- Function for swerb_loc_confidences delete trigger
  --
  -- GPL_notice(`  --', `2017', `Jake Gordon, <jacob.gordon@duke.edu>')

  DECLARE

  BEGIN

  RETURN NULL;
  END;
$$;


SELECT 'swerb_loc_confidences_trigger' AS trigger;
CREATE TRIGGER swerb_loc_confidences_trigger
  AFTER INSERT OR UPDATE
  ON swerb_loc_confidences FOR EACH ROW
  EXECUTE PROCEDURE swerb_loc_confidences_func();

SELECT 'swerb_loc_confidences_delete_trigger' AS trigger;
CREATE TRIGGER swerb_loc_confidences_delete_trigger
  AFTER DELETE
  ON swerb_loc_confidences FOR EACH ROW
  EXECUTE PROCEDURE swerb_loc_confidences_delete_func();
