dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl


dnl plpgsql fragment for BLAH
dnl
dnl Syntax: BLAH(ARG)
dnl
dnl ARG   description
dnl
changequote({,})
define({BLAH},{
})dnl
changequote(`,')dnl

--  
-- swerb_loc_gps
--
SELECT 'swerb_loc_gps' AS table;

SELECT 'swerb_loc_gps_func' AS function;
CREATE FUNCTION swerb_loc_gps_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for swerb_loc_gps insert and update triggers
  --
  -- GPL_notice(`  --', `2012', `The Meme Factory, Inc., http://www.meme.com/')

  IF TG_OP = 'UPDATE' THEN
    cannot_change(`SWERB_LOC_GPS', `SWId')
  END IF;

  -- Can't have a GPS_Datetime date that's not the same as the departure date.
  PERFORM 1
  FROM swerb_data
       JOIN swerb_bes ON (swerb_bes.beid = swerb_data.beid)
       JOIN swerb_departs_data ON (swerb_departs_data.did = swerb_bes.did)
    WHERE swerb_data.swid = NEW.swid
          AND swerb_departs_data.date <> NEW.gps_datetime::DATE
    LIMIT 1;
  IF FOUND THEN
      RAISE EXCEPTION 'SWId %: GPS_Datetime %: The date portion of the SWERB_LOC_GPS.GPS_Datetime value must be equal to the related SWERB_DEPARTS_DATA.Date value'
                    , NEW.swid
                    , NEW.gps_datetime;
    RETURN NULL;
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'swerb_loc_gps_trigger' AS trigger;
CREATE TRIGGER swerb_loc_gps_trigger
  AFTER INSERT OR UPDATE
  ON swerb_loc_gps FOR EACH ROW
  EXECUTE PROCEDURE swerb_loc_gps_func();
