dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2010, Karl O. Pinc
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl


dnl plpgsql fragment for BLAH
dnl
dnl Syntax: BLAH(ARG)
dnl
dnl ARG   description
dnl
changequote({,})
define({BLAH},{
})dnl
changequote(`,')dnl

--  
-- toothcodes
--
SELECT 'toothcodes' AS table;

SELECT 'toothcodes_func' AS function;
CREATE FUNCTION toothcodes_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for toothcodes insert and update triggers
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')

  -- Cannot have 2 adult or 2 baby teeth in the same location.
  PERFORM 1
    FROM toothcodes
    WHERE toothcodes.tooth <> NEW.tooth
          AND toothcodes.toothsite = NEW.toothsite
          AND toothcodes.deciduous = NEW.deciduous
    LIMIT 1;
  IF FOUND THEN
    RAISE EXCEPTION 'Toothsite %: Deciduous %: Cannot have more than one adult or one deciduous tooth in any given site within the mouth',
                    NEW.toothsite,
                    NEW.deciduous;
    RETURN NULL;
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'toothcodes_trigger' AS trigger;
CREATE TRIGGER toothcodes_trigger
  AFTER INSERT OR UPDATE
  ON toothcodes FOR EACH ROW
  EXECUTE PROCEDURE toothcodes_func();
