dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl


dnl plpgsql fragment for BLAH
dnl
dnl Syntax: BLAH(ARG)
dnl
dnl ARG   description
dnl
changequote({,})
define({BLAH},{
})dnl
changequote(`,')dnl

--  
-- trees
--
SELECT 'trees' AS table;

SELECT 'trees_func' AS function;
CREATE FUNCTION trees_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for trees insert and update triggers
  --
  -- GPL_notice(`  --', `2012', `The Meme Factory, Inc., http://www.meme.com/')

  -- Trees must be located in a grove.
  PERFORM 1
    FROM swerb_gws
    WHERE swerb_gws.loc = NEW.loc
          AND swerb_gws.type <> 'bb_swerb_gws_grove'
    LIMIT 1;
  IF FOUND THEN
    RAISE EXCEPTION 'Tid %: Loc %: Tree %: Trees can only be related to SWERB_GWS rows with a Type value of bb_swerb_gws_grove'
                  , NEW.tid
                  , NEW.loc
                  , NEW.tree;
    RETURN NULL;
  END IF;

  RETURN NULL;
  END;
$$;



SELECT 'trees_trigger' AS trigger;
CREATE TRIGGER trees_trigger
  AFTER INSERT OR UPDATE
  ON trees FOR EACH ROW
  EXECUTE PROCEDURE trees_func();
