dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2010, Karl O. Pinc
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl

--  
-- tstates
--
SELECT 'tstates' AS table;

SELECT 'tstates_func' AS function;
CREATE FUNCTION tstates_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for tstates insert and update triggers
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')

  IF TG_OP = 'UPDATE' THEN
    -- Cannot change the missing tooth code.
    restrict_change(`TSTATES', `Tstate', bb_tooth_missing)
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'tstates_delete_func' AS function;
CREATE FUNCTION tstates_delete_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  -- Function for tstates delete trigger
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')

  DECLARE

  BEGIN

  restrict_delete(`TSTATES', `Tstate', bb_tooth_missing)

  RETURN NULL;
  END;
$$;


SELECT 'tstates_trigger' AS trigger;
CREATE TRIGGER tstates_trigger
  AFTER INSERT OR UPDATE
  ON tstates FOR EACH ROW
  EXECUTE PROCEDURE tstates_func();

SELECT 'tstates_delete_trigger' AS trigger;
CREATE TRIGGER tstates_delete_trigger
  AFTER DELETE
  ON tstates FOR EACH ROW
  EXECUTE PROCEDURE tstates_delete_func();
