dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2010, 2011, Karl O. Pinc
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl
include(`seqmacros.m4')dnl

--  
-- ulnas
--
SELECT 'ulnas' AS table;

SELECT 'ulnas_before_insert_func' AS function;
CREATE FUNCTION ulnas_before_insert_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for ulnas before insert trigger
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')
  --
  -- Remarks:
  -- WARNING: See remarks in ulnas_func().

    _init_seq_value(`ULNAS', `Dartid', `Ulseq')

    RETURN NEW;
  END;
$$;

SELECT 'ulnas_func' AS function;
CREATE FUNCTION ulnas_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for ulnas insert and update triggers
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')
  --
  -- Remarks:

    _seq_insert_update_func(`ULNAS', `Ulid', `Dartid', `Ulseq')

  RETURN NULL;
  END;
$$;


SELECT 'ulnas_delete_func' AS function;
CREATE FUNCTION ulnas_delete_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  SECURITY DEFINER
  bb_function_set_search_path
  AS $$
  -- Function for ulnas delete trigger
  --
  -- GPL_notice(`  --', `2010', `Karl O. Pinc <kop@meme.com>')
  --
  -- Remarks:
  -- WARNING: See remarks in ulnas_func().

  BEGIN

    _fill_seq_gap(`ULNAS', `Ulid', `Dartid', `Ulseq')

  RETURN NULL;
  END;
$$;

SELECT 'ulnas_before_insert_trigger' AS trigger;
CREATE TRIGGER ulnas_before_insert_trigger
  BEFORE INSERT
  ON ulnas FOR EACH ROW
  EXECUTE PROCEDURE ulnas_before_insert_func();

SELECT 'ulnas_trigger' AS trigger;
CREATE TRIGGER ulnas_trigger
  AFTER INSERT OR UPDATE
  ON ulnas FOR EACH ROW
  EXECUTE PROCEDURE ulnas_func();

SELECT 'ulnas_delete_trigger' AS trigger;
CREATE TRIGGER ulnas_delete_trigger
  AFTER DELETE
  ON ulnas FOR EACH ROW
  EXECUTE PROCEDURE ulnas_delete_func();
