dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2007, 2008, Karl O. Pinc
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl

dnl m4 includes
include(`copyright.m4')dnl
include(`constants.m4')dnl
include(`macros.m4')dnl

--  
-- unksnames
--
SELECT 'unksnames' AS table;

SELECT 'unksnames_func' AS function;
CREATE FUNCTION unksnames_func ()
  RETURNS trigger
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$
  BEGIN
  -- Function for unksnames insert and update triggers
  --
  -- GPL_notice(`  --', `2007, 2008', `Karl O. Pinc <kop@meme.com>')

  -- Can't have a unksname that's also a sname.
  PERFORM 1
    FROM biograph
    WHERE biograph.sname = NEW.unksname
    LIMIT 1;
  IF FOUND THEN
    RAISE EXCEPTION '%: Cannot have a UNKSNAMES.Unksname that is also a BIOGRAPH.Sname value'
                  , NEW.unksname;
    RETURN NULL;
  END IF;

  RETURN NULL;
  END;
$$;


SELECT 'unksnames_trigger' AS trigger;
CREATE TRIGGER unksnames_trigger
  AFTER INSERT OR UPDATE
  ON unksnames FOR EACH ROW
  EXECUTE PROCEDURE unksnames_func();
