dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl Copyright (C) 2005, 2008, Karl O. Pinc
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Handle inserts into the cycpoints_cycles view.
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl
dnl m4 includes
include(`copyright.m4')
include(`constants.m4')
include(`macros.m4')
dnl

CREATE OR REPLACE FUNCTION
  _cycpoints_cycles_insert(this_row cycpoints_cycles)
  RETURNS cycpoints_cycles
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$

  -- Handle inserts into the cycpoints_cycles view.
  --
  -- GPL_notice(`  --', `2005, 2007, 2008', `Karl O. Pinc <kop@meme.com>')
  --
  -- Syntax:  _cycpoints_cycles_insert(this_row)
  --
  -- Input:
  --   this_row  A the cycpoints_cycles row to insert.
  --
  -- Returns:
  --
  -- Remarks:


  DECLARE

  BEGIN

    -- Check that the supplied Cid and Sname go together.
    PERFORM 1
      FROM cycles
      WHERE cid = this_row.cid
            AND sname <> this_row.sname;
    IF FOUND THEN
      RAISE EXCEPTION '%: %: Cid Sname mismatch'
                      , this_row.cid
                     , this_row.sname;
      RETURN NULL;
    END IF;

    RETURN this_row;
  END;
$$;

grant_func_priv(`_cycpoints_cycles_insert(cycpoints_cycles)')
