dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Raise an exception.
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl
dnl m4 includes
include(`copyright.m4')
include(`constants.m4')
include(`macros.m4')
dnl

SELECT '_raise_babase_exception(TEXT)';
CREATE OR REPLACE FUNCTION
  _raise_babase_exception(msg TEXT)
  RETURNS BOOLEAN
  LANGUAGE plpgsql
  bb_function_set_search_path
  AS $$

  -- Raise an exception.
  --
  -- GPL_notice(`  --', `2007', `Karl O. Pinc <kop@meme.com>')
  --
  -- Syntax:  _raise_babase_exception(msg)
  --
  -- Input:
  --  msg  The text raised in the exception.
  --
  -- Returns: FALSE
  --
  -- Side Effects:
  --   Raises an exception.
  --
  -- Remarks:
  --   Called by views that don't select anything.


  DECLARE

  BEGIN
    RAISE EXCEPTION '%', msg;
    RETURN FALSE;
  END;
$$;
