dnl Copyright (C) 2012, 2014 The Meme Factory, Inc.  http://www.meme.com/
dnl Copyright (C) 2005, 2008, Karl O. Pinc  <kop@meme.com>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Remove all functions supporting view rules from the database
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl Bugs:
dnl  The abstraction of the datatypes that uses column names does not
dnl really work.  Combinations of errors and changing table definition
dnl can leave an old function lying around.
dnl
dnl m4 includes
include(`copyright.m4')
include(`types.m4')

--
-- Remove all functions from the database that support views so
-- we can re-create them with our creation scripts.
--

--
-- Functions
--

DROP FUNCTION _error_immutable_view() CASCADE;

--DROP FUNCTION _cycpoints_cycles_insert(cycpoints_cycles);

--DROP FUNCTION _interact_insert(interact);

--
-- Triggers
--
DROP FUNCTION actor_actees_insert_func() CASCADE;
DROP FUNCTION actor_actees_update_func() CASCADE;
DROP FUNCTION actor_actees_delete_func() CASCADE;

DROP FUNCTION interact_insert_func() CASCADE;
DROP FUNCTION interact_update_func() CASCADE;
DROP FUNCTION interact_delete_func() CASCADE;

DROP FUNCTION interact_sorted_insert_func() CASCADE;
DROP FUNCTION interact_sorted_update_func() CASCADE;
DROP FUNCTION interact_sorted_delete_func() CASCADE;

DROP FUNCTION points_insert_func() CASCADE;
DROP FUNCTION points_update_func() CASCADE;
DROP FUNCTION points_delete_func() CASCADE;

DROP FUNCTION swerb_upload_insert_func() CASCADE;

DROP FUNCTION swerb_loc_gps_xy_insert_func() CASCADE;
DROP FUNCTION swerb_loc_gps_xy_update_func() CASCADE;
DROP FUNCTION swerb_loc_gps_xy_delete_func() CASCADE;

DROP FUNCTION swerb_gw_loc_data_xy_insert_func() CASCADE;
DROP FUNCTION swerb_gw_loc_data_xy_update_func() CASCADE;
DROP FUNCTION swerb_gw_loc_data_xy_delete_func() CASCADE;

DROP FUNCTION quads_insert_func() CASCADE;
DROP FUNCTION quads_update_func() CASCADE;
DROP FUNCTION quads_delete_func() CASCADE;

DROP FUNCTION swerb_data_xy_insert_func() CASCADE;
DROP FUNCTION swerb_data_xy_update_func() CASCADE;
DROP FUNCTION swerb_data_xy_delete_func() CASCADE;

DROP FUNCTION swerb_departs_insert_func() CASCADE;
DROP FUNCTION swerb_departs_update_func() CASCADE;
DROP FUNCTION swerb_departs_delete_func() CASCADE;
