dnl Copyright (C) 2014 Jake Gordon <jacob.gordon@duke.edu>
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Functions and triggers to prevent insert, update, and delete into
dnl the auto generated views.
dnl
dnl Jake Gordon <jacob.gordon@duke.edu>
dnl
dnl

-- Triggers for dsamples to prevent insert/update/delete.

SELECT 'dsamples_insert_trigger' AS trigger;
CREATE TRIGGER dsamples_insert_trigger
  INSTEAD OF INSERT
  ON dsamples FOR EACH ROW
  EXECUTE PROCEDURE _error_immutable_view();

SELECT 'dsamples_update_trigger' AS trigger;
CREATE TRIGGER dsamples_update_trigger
  INSTEAD OF UPDATE
  ON dsamples FOR EACH ROW
  EXECUTE PROCEDURE _error_immutable_view();

SELECT 'dsamples_delete_trigger' AS trigger;
CREATE TRIGGER dsamples_delete_trigger
  INSTEAD OF DELETE
  ON dsamples FOR EACH ROW
  EXECUTE PROCEDURE _error_immutable_view();
