dnl Copyright (C) 2012 The Meme Factory, Inc., http://www.meme.com/
dnl
dnl    This file is part of Babase.
dnl
dnl    Babase is free software; you can redistribute it and/or modify
dnl    it under the terms of the GNU General Public License as published by
dnl    the Free Software Foundation; either version 3 of the License, or
dnl    (at your option) any later version.
dnl
dnl    This program is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl    GNU General Public License for more details.
dnl
dnl    You should have received a copy of the GNU General Public License
dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
dnl
dnl Functions and triggers to allow insert, update, and delete into
dnl the pcv_stats view.
dnl
dnl Karl O. Pinc <kop@meme.com>
dnl
dnl
dnl m4 includes
include(`copyright.m4')
include(`constants.m4')
include(`macros.m4')
dnl


SELECT 'pcv_stats_insert_trigger' AS trigger;
CREATE TRIGGER pcv_stats_insert_trigger
  INSTEAD OF INSERT
  ON pcv_stats FOR EACH ROW
  EXECUTE PROCEDURE _error_immutable_view();

SELECT 'pcv_stats_update_trigger' AS trigger;
CREATE TRIGGER pcv_stats_update_trigger
  INSTEAD OF UPDATE
  ON pcv_stats FOR EACH ROW
  EXECUTE PROCEDURE _error_immutable_view();

SELECT 'pcv_stats_delete_trigger' AS trigger;
CREATE TRIGGER pcv_stats_delete_trigger
  INSTEAD OF DELETE
  ON pcv_stats FOR EACH ROW
  EXECUTE PROCEDURE _error_immutable_view();
