<?xml version='1.0'?> 
<xsl:stylesheet  
       xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  version="1.0"> 
  <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/xhtml/chunk.xsl"/> 

  <!-- Copyright (C) 2005-2008,2010, Karl O. Pinc

       This file is part of Babase.

       Babase is free software; you can redistribute it and/or modify
       it under the terms of the GNU General Public License as published by
       the Free Software Foundation; either version 3 of the License, or
       (at your option) any later version.

       This program is distributed in the hope that it will be useful,
       but WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       GNU General Public License for more details.

       You should have received a copy of the GNU General Public License
       along with Babase.  If not, see <http://www.gnu.org/licenses/>.

       This stylesheet delivers the content of all "code" elements with
       a "role" attribute of "view".
       We use it to get the view SQL code out of the documentation. -->
  <xsl:output method="text" encoding="iso8859-1"/>

  <xsl:template match='code[@role="view"]'>
    <!-- Get content of the view's code block(s). -->
    <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match='node()'>
    <!-- Recur through children. -->
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/">
   <xsl:text>include(`copyright.m4')dnl
include(`grants.m4')dnl

-- </xsl:text>
   <xsl:value-of select="$view-name"/>
   <xsl:text>
CREATE OR REPLACE VIEW </xsl:text>
   <xsl:value-of select="$view-name"/>
   <xsl:text>
  AS </xsl:text>
   <xsl:apply-templates/>
   <xsl:text>;

grant_priv(`</xsl:text>
   <xsl:value-of select="$view-name"/>
   <xsl:text>')
</xsl:text>
  </xsl:template>

</xsl:stylesheet>  
