m4_dnl Copyright (C) 2010,2011, Karl O. Pinc
m4_dnl
m4_dnl    This file is part of Babase.
m4_dnl
m4_dnl    Babase is free software; you can redistribute it and/or modify
m4_dnl    it under the terms of the GNU General Public License as published by
m4_dnl    the Free Software Foundation; either version 3 of the License, or
m4_dnl    (at your option) any later version.
m4_dnl
m4_dnl    This program is distributed in the hope that it will be useful,
m4_dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
m4_dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
m4_dnl    GNU General Public License for more details.
m4_dnl
m4_dnl    You should have received a copy of the GNU General Public License
m4_dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
m4_dnl
m4_dnl Karl O. Pinc <kop@meme.com>
m4_dnl
m4_dnl
m4_dnl m4 macro file for making TESTES_foo testes documentation.
m4_dnl
m4_dnl Input:
m4_dnl                  (in lower case)
m4_dnl
m4_define(`TESTES_SUFFIX', m4_translit(testes_suffix, a-z, A-z))m4_dnl
<?xml version='1.0'?>
<!DOCTYPE tgroup PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
         "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
         [
          <!ENTITY  plusmn  "&#x00B1;"> <!-- recommended in case external
                                             entity not available -->

          <!-- Use symbols for hardcoded Babase data -->
          <!ENTITY  % constants SYSTEM "../constants">
          %constants;
]>
<!-- Copyright (C) 2010, 2011 Karl O. Pinc <kop@meme.com> and others
   - See document output for full copyright information. -->

<!-- DO NOT EDIT THIS FILE.  It was automatically generated.  Edit
   - the testes_stats_cols.xml.m4 file instead.  (Files _should_ be
   - re-created by typing 'make' at the command line.) -->

          <tgroup cols="3" colsep="1" rowsep="1">
            <thead>
              <row>
                <entry>Column</entry> 
                <entry>From</entry>
                <entry>Description</entry>
              </row>
            </thead>
            <tbody>
              <row>
                <entry>Dartid</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Dartid"/>
                (computed)</entry>

                <entry>Identifier of the darting event.</entry>
              </row>
              <row>
                <entry>Testllengthsamps</entry>

                <entry>Computed</entry>

                <entry>Number of <olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/> rows having the given Dartid
                value and also having a <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testside"/> value of
                <literal>&bb_lefttestes;</literal> and a
                non-<literal>NULL</literal> <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testlength"/> value -- the number of
                left testicle length measurements taken during the
                darting.<footnote>

                   <para><literal>NULL</literal> values do not count
                   toward the number of measurements.</para>

                 </footnote></entry>
              </row>
              <row>
                <entry>Testllength_mean</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testlength"/> (computed)</entry>

                <entry>The arithmetic mean of the left testicle length
                measurements related to the given Dartid -- the mean
                of the left testicle length measurements taken during
                the darting.</entry>
              </row>
              <row>
                <entry>Testllength_stddev</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testlength"/> (computed)</entry>

                <entry>The standard deviation of the left testicle
                length measurements related to the given Dartid -- the
                standard deviation of the left testicle length
                measurements taken during the darting.</entry>
              </row>
              <row>
                <entry>Testlwidthsamps</entry>

                <entry>Computed</entry>

                <entry>Number of <olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/> rows having the given Dartid
                value and also having a <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testside"/> value of
                <literal>&bb_lefttestes;</literal> and a
                non-<literal>NULL</literal> <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testwidth"/> value -- the number of
                left testicle width measurements taken during the
                darting.<footnote>

                   <para><literal>NULL</literal> values do not count
                   toward the number of measurements.</para>

                 </footnote></entry>
              </row>
              <row>
                <entry>Testlwidth_mean</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testwidth"/> (computed)</entry>

                <entry>The arithmetic mean of the left testicle width
                measurements related to the given Dartid -- the mean
                of the left testicle width measurements taken during
                the darting.</entry>
              </row>
              <row>
                <entry>Testlwidth_stddev</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testwidth"/> (computed)</entry>

                <entry>The standard deviation of the left testicle
                width measurements related to the given Dartid -- the
                standard deviation of the left testicle width
                measurements taken during the darting.</entry>
              </row>
              <row>
                <entry>Testrlengthsamps</entry>

                <entry>Computed</entry>

                <entry>Number of <olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/> rows having the given Dartid
                value and also having a <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testside"/> value of
                <literal>&bb_righttestes;</literal> and a
                non-<literal>NULL</literal> <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testlength"/> value -- the number of
                right testicle length measurements taken during the
                darting.<footnote>

                   <para><literal>NULL</literal> values do not count
                   toward the number of measurements.</para>

                 </footnote></entry>
              </row>
              <row>
                <entry>Testrlength_mean</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testlength"/> (computed)</entry>

                <entry>The arithmetic mean of the right testicle length
                measurements related to the given Dartid -- the mean
                of the right testicle length measurements taken during
                the darting.</entry>
              </row>
              <row>
                <entry>Testrlength_stddev</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testlength"/> (computed)</entry>

                <entry>The standard deviation of the right testicle
                length measurements related to the given Dartid -- the
                standard deviation of the right testicle length
                measurements taken during the darting.</entry>
              </row>
              <row>
                <entry>Testrwidthsamps</entry>

                <entry>Computed</entry>

                <entry>Number of <olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/> rows having the given Dartid
                value and also having a <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testside"/> value of
                <literal>&bb_righttestes;</literal> and a
                non-<literal>NULL</literal> <olink
                targetdoc="babase_system" targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testwidth"/> value -- the number of
                right testicle width measurements taken during the
                darting.<footnote>

                   <para><literal>NULL</literal> values do not count
                   toward the number of measurements.</para>

                 </footnote></entry>
              </row>
              <row>
                <entry>Testrwidth_mean</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testwidth"/> (computed)</entry>

                <entry>The arithmetic mean of the right testicle width
                measurements related to the given Dartid -- the mean
                of the right testicle width measurements taken during
                the darting.</entry>
              </row>
              <row>
                <entry>Testrwidth_stddev</entry>

                <entry><olink targetdoc="babase_system"
                targetptr="TESTES_`'TESTES_SUFFIX"/>.<olink
                targetdoc="babase_system"
                targetptr="Testes_`'testes_suffix`'-Testwidth"/> (computed)</entry>

                <entry>The standard deviation of the right testicle
                width measurements related to the given Dartid -- the
                standard deviation of the right testicle width
                measurements taken during the darting.</entry>
              </row>
            </tbody>
          </tgroup>
<!--
 Local Variables:
 mode: xml
 End:
 -->
