# Copyright (C) 2014 The Meme Factory, Inc.  http://www.meme.com/
# Copyright (C) 2010, 2011 Karl O. Pinc <kop@meme.com>
#
#    This file is part of Babase.
#
#    Babase is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
#
# Define the variables with diagram image paths:
# EPS_TARGETS, PNG_TARGETS, TRASPARENT_PNG_TARGETS, SVG_TARGETS
# And DIAGRAM_PATH.
#
# Karl O. Pinc <kop@meme.com>
#
# Bugs:

# This file is in the dir with the diagrams.
DIAGRAM_PATH := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))

# All the dia documents that are not views.
CHADO_DIA_SOURCES = chado_sequence.dia chado_key.dia chado_analysis.dia \
                    chado_nd_meta.dia chado_nd_protocol.dia chado_stock.dia \
                    chado_nd_stock.dia chado_bb_experiment_analysis.dia \
                    chado_nd_sequence.dia \
                    tracking_libraries.dia library_chado_integration.dia
DIA_SOURCES = sex.dia cendemog.dia interactions.dia \
              lifeevents.dia tableguide.dia sex_stats.dia \
              mpi.dia weather.dia weatherhawk.dia dartlogmorpho.dia \
              dartphysio.dia dartteethticks.dia dartsamp.dia\
              potential_dads-simple.dia \
              potential_dads-presence.dia potential_dads-computed.dia \
              potential_dads-interactions.dia swerbcore.dia swerblocs.dia \
              $(CHADO_DIA_SOURCES) warnings.dia hybridscores.dia

# Views that don't have their own diagram.
UNDIAGRAMMED_VIEWS = points_sorted census_demog_sorted \
               cycpoints_cycles_sorted interact_sorted \
               cycles_sexskins_sorted demog_census_sorted \
               sexskins_cycles_sorted min_maxs_sorted \
               potential_dads swerb_upload dsamples

# Add in the views that have diagrams.
DIA_SOURCES += $(VIEW_NAMES:%=%.dia)
DIA_SOURCES := $(filter-out $(UNDIAGRAMMED_VIEWS:%=%.dia),$(DIA_SOURCES))

# The variables we actually want.
EPS_TARGETS := $(DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%.eps)
PNG_TARGETS := $(DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%.png)
TRANSPARENT_PNG_TARGETS := $(DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%_trans.png)
SVG_TARGETS := $(DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%.svg)

CHADO_EPS_TARGETS := $(CHADO_DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%.eps)
CHADO_PNG_TARGETS := $(CHADO_DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%.png)
CHADO_TRANSPARENT_PNG_TARGETS \
                  := $(CHADO_DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%_trans.png)
CHADO_SVG_TARGETS := $(CHADO_DIA_SOURCES:%.dia=$(DIAGRAM_PATH)%.svg)
