<?xml version='1.0'?>
<xsl:stylesheet version='1.0'
                xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                xmlns:babase="babase.accessibility.namespace">
  <babase:comment>
  Copyright (C) 2005, 2008, Karl O. Pinc

      This file is part of Babase.

      Babase is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 3 of the License, or
      (at your option) any later version.

      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with Babase.  If not, see http://www.gnu.org/licenses/.

  There, that set it up so we can have comments.
  From: http://www.dpawson.co.uk/xsl/index.html
        http://www.dpawson.co.uk/xsl/sect2/comments.html#d2747e112

  If this were not "top level" we'd have to also have
  <xsl:fallback/>
  somewhere in here.  And apparently we're not top level.
  Maybe I should be using <!-- --> style comments instead?
  I don't as I thought they made it into the formatting output
  at least.

  The topmost 2 lines are basic and required Header Information.
  </babase:comment>
  <babase:comment>
    This stylesheet is used by the Makefile to customize PDF output.
  </babase:comment>
  <babase:comment>
    Use the standard babase style.
    We must use include, which means we can't override these
    settings, instead of import where we could, I think because
    we're using an xml fragment to give to xmlto rather than
    writing our own customization layer.  Import can only be
    used at top level, where we apparently are not.
  </babase:comment>
  <xsl:include href="babase_system.xsl"/>

  <babase:comment>
   This style adds that page break after TOC.
  </babase:comment>
<xsl:attribute-set name="toc.margin.properties">
  <xsl:attribute name="break-after">page</xsl:attribute>
  </xsl:attribute-set>  

<babase:comment>
    Have external links show up in footnotes.
  </babase:comment>
  <xsl:param name="ulink.footnotes" select="1"/>

<babase:comment>
  Have space between columns of tables.

<xsl:attribute-set name="table.cell.padding">
  <xsl:attribute name="padding-left">1em</xsl:attribute>
  <xsl:attribute name="padding-right">1em</xsl:attribute>
  <xsl:attribute name="padding-top">2pt</xsl:attribute>
  <xsl:attribute name="padding-bottom">2pt</xsl:attribute>
</xsl:attribute-set>
  </babase:comment>

</xsl:stylesheet>
