m4_dnl Copyright (C) 2009-2011, Karl O. Pinc
m4_dnl
m4_dnl    This file is part of Babase.
m4_dnl
m4_dnl    Babase is free software; you can redistribute it and/or modify
m4_dnl    it under the terms of the GNU General Public License as published by
m4_dnl    the Free Software Foundation; either version 3 of the License, or
m4_dnl    (at your option) any later version.
m4_dnl
m4_dnl    This program is distributed in the hope that it will be useful,
m4_dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
m4_dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
m4_dnl    GNU General Public License for more details.
m4_dnl
m4_dnl    You should have received a copy of the GNU General Public License
m4_dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
m4_dnl
m4_dnl Karl O. Pinc <kop@meme.com>
m4_dnl
m4_dnl
m4_dnl m4 macro file for making TESTES_foo testes documentation.
m4_dnl
m4_dnl Input:
m4_dnl   testes_suffix  m4 variable containing the correct suffix
m4_dnl                  (in lower case)
m4_dnl
m4_define(`TESTES_SUFFIX', m4_translit(testes_suffix, a-z, A-z))m4_dnl
<?xml version='1.0'?>
<!DOCTYPE section PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
         "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
         [
          <!ENTITY  plusmn  "&#x00B1;"> <!-- recommended in case external
                                             entity not available -->

  <!-- Use symbols for hardcoded Babase data -->
  <!ENTITY % entities SYSTEM "entities">
  %entities;
  <!ENTITY  % constants SYSTEM "constants">
  %constants;
]>

<!-- Copyright (C) 2009-2011 Karl O. Pinc <kop@meme.com> and others
   - See document output for full copyright information. -->

<!-- DO NOT EDIT THIS FILE.  It was automatically generated.  Edit
   - the testes.xml.m4 file instead.  (Files _should_ be re-created by
   - typing 'make' at the command line.) -->


      <section id="TESTES_`'TESTES_SUFFIX`'"
               xreflabel="TESTES_`'TESTES_SUFFIX`'">
        <title>TESTES_`'TESTES_SUFFIX`' (Darting Testes
        m4_ifelse(testes_suffix, `arc', `circumference', `Diameter')
        Data)</title>

        <para>TESTES_`'TESTES_SUFFIX`' contains one row for every
        darting event for every recorded measurement of testicle
        width and length
        m4_ifelse(testes_suffix, `arc', `circumference', `diameter').</para>

        <caution>
          <para>The <olink targetdoc="babase_system"
          targetptr="TESTES_ARC">TESTES_ARC</olink> table contains
          testes measurements of a portion of the testicle
          circumference.  The <olink targetdoc="babase_system"
          targetptr="TESTES_DIAM">TESTES_DIAM</olink> table contains
          testes measurements of the diameter.  The two tables are
          otherwise identical in that they have the same structure
          and have corresponding validation rules.</para>
        </caution>

        <note>
          <para>The <quote>pairing</quote> of the width and length
          measurements within this table exists to make data storage
          convenient; no special relationship is implied regarding the
          order in which the measurements were taken.  For example, if
          there are 3 length measurements taken during a darting and 2
          width measurements the width and length measurements may have
          been taken in either of the following orders, as well as
          other possible orders not listed here: length1, length2,
          length3, width1, width2 or length1, width1, length2, width2,
          length3.  In other words the value of the Seq column
          describes the order in which the length measurements were
          taken and the order in which width measurements were taken
          but says nothing about the interspersing of length and width
          measurements.<footnote>

            <para>The alternative to this, an approach closer to the
            <quote>ideal</quote> database design, is to have separate
            tables for width and length measurements.  This seems
            excessive.</para>
            </footnote>
          </para>
        </note>

        <para>Either the width or the length must be specified -- both
        <xref linkend="Testes_`'testes_suffix`'-Testwidth"/> and <xref
        linkend="Testes_`'testes_suffix`'-Testlength"/> cannot be
        <literal>NULL</literal> in the same row.</para>

        <para>There can only be one measurement taken per darting per
        testicle per measurement sequence number -- <xref
        linkend="Testes_`'testes_suffix`'-Testseq"/> must be unique per <xref
        linkend="Testes_`'testes_suffix`'-Dartid"/> per <xref
        linkend="Testes_`'testes_suffix`'-Testside"/>.</para>

        <para>Once a <xref linkend="Testes_`'testes_suffix`'-Testwidth"/> value is
        <literal>NULL</literal> all the rows (for the same darting)
        with higher <xref linkend="Testes_`'testes_suffix`'-Testseq"/> values must also
        have a <literal>NULL</literal> <xref
        linkend="Testes_`'testes_suffix`'-Testwidth"/> value.  The same is true of the
        <xref linkend="Testes_`'testes_suffix`'-Testlength"/> column.<footnote>

            <para>This rule is a result of the aforementioned design
            choice that places <xref linkend="Testes_`'testes_suffix`'-Testwidth"/> and
            <xref linkend="Testes_`'testes_suffix`'-Testlength"/> in the same table.  A
            consequence of this choice is that this rule must exist to
            ensure that <xref linkend="Testes_`'testes_suffix`'-Testseq"/> values are,
            effectively, contiguous.</para>

            <para>Note that this condition must remain true even while
            the rows are in the process of <olink targetdoc="babase_system"
            targetptr="Automatic-Sequencing">automatic
            re-sequencing</olink>.  It may be that some combinations of
            data values will simply not work with all possible
            <code>UPDATE</code> statements that change the row
            sequencing.  Those experiencing problems should delete the
            rows in question and re-insert them with the correct
            sequence numbers.</para>

          </footnote></para>

        <para>An individual must be male to have a row in this
        table.</para>

        <para>Individuals at least &bb_adult_testes_age; as of the
        <olink targetdoc="babase_system" targetptr="DARTINGS"/>.<olink targetdoc="babase_system" targetptr="Dartings-Date"/>
        must have testes length (<xref linkend="Testes_`'testes_suffix`'-Testlength"/>)
        measurement of at least &bb_min_adult_`'testes_suffix`'_testlength;mm and a
        testes width measurement (<xref linkend="Testes_`'testes_suffix`'-Testwidth"/>)
        of at least &bb_min_adult_`'testes_suffix`'_testwidth;mm.  The system will report
        a warning when individuals darted when less than
        &bb_adult_testes_age; old have testes length measurements
        less than &bb_min_adult_`'testes_suffix`'_testlength;mm or have testes width
        measurements less than &bb_min_adult_`'testes_suffix`'_testwidth;mm.</para>

        <section id="Testes_`'testes_suffix`'-Testesid" xreflabel="Testesid">
          <title>Testesid (Testes measurements Identifier)</title>

          <para>A unique identifier.  This is an automatically
          generated sequential number that uniquely identifies the row
          and may be used to refer to a particular testes
          measurement.</para>

          <para>This column is automatically maintained by the
          database, cannot be changed, and must not be
          <literal>NULL</literal>.</para>
        </section>

        <section id="Testes_`'testes_suffix`'-Dartid" xreflabel="Dartid">
          <title>Dartid (Darting Identifier)</title>

          <para>The darting event during which the testes measurements
          were taken -- a <olink targetdoc="babase_system" targetptr="DARTINGS"/>.<olink targetdoc="babase_system" targetptr="Dartings-Dartid"/> value.  This column cannot be
          changed and may not be <literal>NULL</literal>.</para>
        </section>

        <section id="Testes_`'testes_suffix`'-Testside" xreflabel="Testside">
          <title>Testside (Testicle measured)</title>

            <para>The testicle measured. The legal values
            are:</para>

            <segmentedlist>
              <title>Valid Testside Values</title>

              <segtitle>Code</segtitle>
              <segtitle>Description</segtitle>

              <seglistitem><seg>L</seg><seg>the left
              testicle</seg></seglistitem>

              <seglistitem><seg>R</seg><seg>the right
              testicle</seg></seglistitem>

            </segmentedlist>

            <para>This column may not be <literal>NULL</literal>.</para>
          </section>

        <section id="Testes_`'testes_suffix`'-Testlength" xreflabel="Testlength">
          <title>Testlength (Testes Length measurement)</title>

          <para>The testes length measurement, in millimeters, with a
          precision of 1/10th of a millimeter.  The minimum value
          allowed is <literal>&bb_min_`'testes_suffix`'_testlength;</literal>
          millimeters.  The maximum value allowed is
          <literal>&bb_max_`'testes_suffix`'_testlength;</literal> millimeters.</para>

          <para>This column may not be <literal>NULL</literal>.</para>
        </section>

        <section id="Testes_`'testes_suffix`'-Testwidth" xreflabel="Testwidth">
          <title>Testwidth (Testes Width measurement)</title>

          <para>The testes width measurement, in millimeters, with a
          precision of 1/10th of a millimeter.  The minimum value
          allowed is <literal>&bb_min_`'testes_suffix`'_testwidth;</literal>
          millimeters.  The maximum value allowed is
          <literal>&bb_max_`'testes_suffix`'_testwidth;</literal> millimeters.</para>

          <para>This column may not be <literal>NULL</literal>.</para>
        </section>

        <section id="Testes_`'testes_suffix`'-Testseq" xreflabel="Testseq">
          <title>Testseq (Testes measurement Sequence)</title>

          <para>A sequence number indicating the order in which the
          measurements were taken.  The first measurement, of each
          testicle, taken during a darting has a Testseq value of
          <literal>1</literal>, the second a value of
          <literal>2</literal>, etc.</para>

          <para>The system automatically re-computes Testseq values to
          ensure that they are contiguous and begin with
          <literal>1</literal>.  Note that the TESTES_`'TESTES_SUFFIX`' rows are
          sequenced within <xref linkend="Testes_`'testes_suffix`'-Dartid"/> within
          <xref linkend="Testes_`'testes_suffix`'-Testside"/> whereas the other darting
          tables are sequenced only within Dartid.  See the <olink targetdoc="babase_system" targetptr="Automatic-Sequencing"/> section for further
          information.</para>

        </section>

      </section>
<!--
 Local Variables:
 mode: xml
 End:
 -->
