m4_dnl Copyright (C) 2009-2011, Karl O. Pinc
m4_dnl
m4_dnl    This file is part of Babase.
m4_dnl
m4_dnl    Babase is free software; you can redistribute it and/or modify
m4_dnl    it under the terms of the GNU General Public License as published by
m4_dnl    the Free Software Foundation; either version 3 of the License, or
m4_dnl    (at your option) any later version.
m4_dnl
m4_dnl    This program is distributed in the hope that it will be useful,
m4_dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
m4_dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
m4_dnl    GNU General Public License for more details.
m4_dnl
m4_dnl    You should have received a copy of the GNU General Public License
m4_dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
m4_dnl
m4_dnl Karl O. Pinc <kop@meme.com>
m4_dnl
m4_dnl
m4_dnl m4 macro file for making TESTES_foo testes documentation.
m4_dnl
m4_dnl Input:
m4_dnl   testes_suffix  m4 variable containing the correct suffix
m4_dnl                  (in lower case)
m4_dnl
m4_define(`TESTES_SUFFIX', m4_translit(testes_suffix, a-z, A-z))m4_dnl
<?xml version='1.0'?>
<!DOCTYPE section PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
         "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
         [
          <!ENTITY  plusmn  "&#x00B1;"> <!-- recommended in case external
                                             entity not available -->

  <!-- Use symbols for hardcoded Babase data -->
  <!ENTITY % entities SYSTEM "entities">
  %entities;
  <!ENTITY  % constants SYSTEM "constants">
  %constants;
]>

<!-- Copyright (C) 2009-2011 Karl O. Pinc <kop@meme.com> and others
   - See document output for full copyright information. -->

<!-- DO NOT EDIT THIS FILE.  It was automatically generated.  Edit
   - the testes.xml.m4 file instead.  (Files _should_ be re-created by
   - typing 'make' at the command line.) -->


      <section id="TESTES_`'TESTES_SUFFIX`'_STATS"
               xreflabel="TESTES_`'TESTES_SUFFIX`'_STATS">
        <title>TESTES_`'TESTES_SUFFIX`'_STATS (darting Testes
        m4_ifelse(testes_suffix, `arc', `circumference', `Diameter')
        Statistics)</title>

        <para>Contains one row for every unique <olink
        targetdoc="babase_system"
        targetptr="Testes_`'testes_suffix`'-Dartid"/> value in the
        <olink targetdoc="babase_system"
        targetptr="TESTES_`'TESTES_SUFFIX`'"/> table.<footnote>

            <para>Note that when no testes length or width
            measurements are taken there are no related <olink
            targetdoc="babase_system"
            targetptr="TESTES_`'TESTES_SUFFIX`'"/> rows and hence no
            row in this view for the given darting.</para>
          </footnote>

        Each row statistically summarizes the <olink
        targetdoc="babase_system"
        targetptr="TESTES_`'TESTES_SUFFIX`'"/> rows having the common
        <olink targetdoc="babase_system"
        targetptr="Testes_`'testes_suffix`'-Dartid"/> value.</para>

        <para>This view is useful when joined with the <olink
        targetdoc="babase_system" targetptr="DARTINGS"/> table on
        <olink targetdoc="babase_system"
        targetptr="Dartings-Dartid"/>.</para>
        <section id="TESTES_`'TESTES_SUFFIX`'_STATS-Definition">
          <title>Definition</title>

          <xi:include 
            href="views/testes_`'testes_suffix`'_stats.xml"
            xmlns:xi="http://www.w3.org/2001/XInclude"/>

          <table frame="all" id="Testes_`'testes_suffix`'_Stats-Columns">
            <title>Columns in the TESTES_`'TESTES_SUFFIX`'_STATS View</title>

            <xi:include 
              href="cols/testes_`'testes_suffix`'_stats_cols.xml"
              xmlns:xi="http://www.w3.org/2001/XInclude"/>

          </table>
        </section>

        <section id="TESTES_`'TESTES_SUFFIX`'_STATS-Operations-Allowed">
          <title>Operations Allowed</title>

          <para>Only SELECT is allowed on
          TESTES_`'TESTES_SUFFIX`'_STATS. INSERT,
          UPDATE, and DELETE are not allowed.</para>
        </section>
      </section>
<!--
 Local Variables:
 mode: xml
 End:
 -->
