m4_dnl Copyright (C) 2010, Karl O. Pinc
m4_dnl
m4_dnl    This file is part of Babase.
m4_dnl
m4_dnl    Babase is free software; you can redistribute it and/or modify
m4_dnl    it under the terms of the GNU General Public License as published by
m4_dnl    the Free Software Foundation; either version 3 of the License, or
m4_dnl    (at your option) any later version.
m4_dnl
m4_dnl    This program is distributed in the hope that it will be useful,
m4_dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
m4_dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
m4_dnl    GNU General Public License for more details.
m4_dnl
m4_dnl    You should have received a copy of the GNU General Public License
m4_dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
m4_dnl
m4_dnl Karl O. Pinc <kop@meme.com>
m4_dnl
m4_dnl Template to create a foo_grp view, a view that contains
m4_dnl the group associated with a particular individual.
m4_dnl
m4_dnl Syntax:
m4_dnl   m4 -P --define=table=foo \
m4_dnl      --define=key=bar \
m4_dnl      --define=sname=baz \
m4_dnl      --define=date=x \
m4_dnl      --define=view=y
m4_dnl
m4_dnl Args:
m4_dnl
m4_dnl table   The table to be joined with members.  This macro is required.
m4_dnl
m4_dnl key     The name of the column to be included in the view as the foreign
m4_dnl         key used when joining with the given table.  This macro is
m4_dnl         required.
m4_dnl
m4_dnl sname   The name of the sname column used to join with members.
m4_dnl         This macro is not required, it defaults to 'sname'.
m4_dnl
m4_dnl date    The name of the date column used to join with members.
m4_dnl         This macro is not required, it defaults to 'date'.
m4_dnl
m4_dnl vname  The name of the created view.  Defaults to 'table_GRP'.
m4_dnl
m4_dnl Remarks:
m4_dnl All 'argument' macros are expected to have lower case values.
m4_dnl
m4_dnl These views exist to make it conveinent for non-sql-savvy to
m4_dnl join with members.
m4_dnl
m4_dnl Bugs:
m4_dnl   Explicitly setting an input macro to it's default causes
m4_dnl and infinite loop.
m4_dnl
m4_dnl  m4 includes
m4_include(`m4_macros.m4')m4_dnl
m4_dnl
m4_ifdef(`vname',
`m4_define(`viewname', upcase(vname)_GRP)',
`m4_define(`viewname', upcase(table)_GRP)')m4_dnl
m4_define(`dvname', m4_translit(viewname,A-Z,a-z))m4_dnl
<?xml version='1.0'?>
<!DOCTYPE para PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
         "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
         [
          <!ENTITY  plusmn  "&#x00B1;"> <!-- recommended in case external
                                             entity not available -->
]>
<!-- Copyright (C) 2005, 2007, 2010 Karl O. Pinc <kop@meme.com> and others
   - See document output for full copyright information. -->

<!-- Core documentation on the viewname view.

   - This is indeed the query that makes the view, so don't break it!

   - The "code" element must have a 'role="view"' attribute
   - so that Babase code generation can get the code
   - and actually make the view!
-->

<para>
<figure id="`'dvname`'-code">
  <title>Query Defining the viewname View</title>
  <literallayout>
<code role="view">SELECT table.*
     , members.grp AS grp
  FROM members, table
  WHERE members.`sname' = table.sname
        AND members.`date' = CAST(`'table.date AS DATE)</code><code>;</code></literallayout>
  </figure>

<!-- Figure containing viewname view diagram. -->

<!-- Use mediaobject role attribute to select either xhtml (html)
     or pdf (fo) file paths.  -->

  <figure id="`'dvname`'-erd">
      <title>Entity Relationship Diagram of the viewname View</title>
      <mediaobject>
        <imageobject role="html">
          <imagedata scalefit="1" width="6in"
            fileref="/diagrams/`'dvname`'.png" format="PNG" />
        </imageobject>
        <imageobject role="dblatex">
          <imagedata scalefit="1" width="6in"
            fileref="/diagrams/`'dvname`'.png" format="PNG" />
        </imageobject>

        <textobject> <phrase>If we could we would display here the
           diagram showing how the viewname view is constructed.</phrase>
        </textobject>
      </mediaobject>
    </figure>
</para>
<!--
 Local Variables:
 mode: xml
 End:
 -->
