m4_dnl Copyright (C) 2012, The Meme Factory, Inc.  http://www.meme.com/
m4_dnl
m4_dnl    This file is part of Babase.
m4_dnl
m4_dnl    Babase is free software; you can redistribute it and/or modify
m4_dnl    it under the terms of the GNU General Public License as published by
m4_dnl    the Free Software Foundation; either version 3 of the License, or
m4_dnl    (at your option) any later version.
m4_dnl
m4_dnl    This program is distributed in the hope that it will be useful,
m4_dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
m4_dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
m4_dnl    GNU General Public License for more details.
m4_dnl
m4_dnl    You should have received a copy of the GNU General Public License
m4_dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
m4_dnl
m4_dnl Karl O. Pinc <kop@meme.com>
m4_dnl
m4_dnl Program to create a docbook document that is a table of those
m4_dnl groups that are auto-generated.
m4_dnl
m4_dnl Syntax:
m4_dnl   m4 -P --define=thesepairs="table[, table] ..."
m4_dnl
m4_dnl Args:
m4_dnl
m4_dnl thesepairs  Pairs consisting of the names of the tables which
m4_dnl             make the views, followed by a /, followed by the
m4_dnl             name of the view.  When the table name and / character
m4_dnl             is omitted then the view names are all table_GRP.
m4_dnl  
m4_dnl Remarks:
m4_dnl All 'argument' macros are expected to have lower case values.
m4_dnl
m4_dnl These views exist to make it conveinent for non-sql-savvy to
m4_dnl join with members.
m4_dnl
m4_dnl Bugs:
m4_dnl
m4_dnl m4 includes
m4_include(`m4_macros.m4')m4_dnl
m4_dnl
m4_define(`make_row',
`	    <row>
	      <entry><olink targetdoc="babase_system" 
                            targetptr="m4_patsubst(`$1', `/.*')"/></entry>
	      <entry><olink targetdoc="babase_system" 
                            targetptr="m4_patsubst(`$1', `.*/')_GRP"/></entry>
	    </row>
')m4_dnl
m4_dnl
<?xml version='1.0'?>
<!DOCTYPE table PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
         "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
         [
          <!ENTITY  plusmn  "&#x00B1;"> <!-- recommended in case external
                                             entity not available -->
]>
<!-- Copyright (C) 2012 The Meme Factory, Inc.  http://www.meme.com/
   - See document output for full copyright information. -->

      <table tocentry="1" frame="all" id="Group-View-Summary-Table">
        <title>The table_GRP Views</title>
	<tgroup cols="2" align="left" colsep="1" rowsep="1">
	  <colspec colname="table" colwidth="3cm"/>
	  <colspec colname="view" colwidth="4cm"/>
	  <tbody>
            <row>
              <entry namest="table" 
                     nameend="table"
                     role="subhead"
                     align="left">Table</entry>
	      <entry namest="view"
                     nameend="view"
                     role="subhead">View</entry> 
	    </row>

foreach(`t', (thesepairs), `make_row(upcase(t))')m4_dnl

          </tbody>
        </tgroup>
      </table>

<!--
 Local Variables:
 mode: xml
 End:
 -->
