m4_dnl Copyright (C) 2012, The Meme Factory, Inc.  http://www.meme.com/
m4_dnl
m4_dnl    This file is part of Babase.
m4_dnl
m4_dnl    Babase is free software; you can redistribute it and/or modify
m4_dnl    it under the terms of the GNU General Public License as published by
m4_dnl    the Free Software Foundation; either version 3 of the License, or
m4_dnl    (at your option) any later version.
m4_dnl
m4_dnl    This program is distributed in the hope that it will be useful,
m4_dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
m4_dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
m4_dnl    GNU General Public License for more details.
m4_dnl
m4_dnl    You should have received a copy of the GNU General Public License
m4_dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
m4_dnl
m4_dnl Karl O. Pinc <kop@meme.com>
m4_dnl
m4_dnl Program to create a docbook section that describes those views
m4_dnl which add a group column to a table and which are auto-generated.
m4_dnl
m4_dnl Syntax:
m4_dnl   m4 -P --define=thesetables="table[, table] ..."
m4_dnl
m4_dnl Args:
m4_dnl
m4_dnl thesetables   The names of the tables which make the views.  The view names
m4_dnl         are all table_GRP.
m4_dnl  
m4_dnl Remarks:
m4_dnl All 'argument' macros are expected to have lower case values.
m4_dnl
m4_dnl These views exist to make it conveinent for non-sql-savvy to
m4_dnl join with members.
m4_dnl
m4_dnl Bugs:
m4_dnl
m4_dnl m4 includes
m4_include(`m4_macros.m4')m4_dnl
m4_dnl
m4_define(`make_section',
`	     <section id="upcase($1)_GRP" xreflabel="upcase($1)_GRP">
              <title>The upcase($1)_GRP View</title>
                <xi:include 
                  href="$1_grp.xml"
                  xmlns:xi="http://www.w3.org/2001/XInclude"/>
            </section>
')m4_dnl
m4_dnl
<?xml version='1.0'?>
<!DOCTYPE section PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
         "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
         [
          <!ENTITY  plusmn  "&#x00B1;"> <!-- recommended in case external
                                             entity not available -->

          <!-- Use symbols for hardcoded Babase data -->
          <!ENTITY % entities SYSTEM "../entities">
          %entities;
]>
<!-- Copyright (C) 2012 The Meme Factory, Inc.  http://www.meme.com/
   - See document output for full copyright information. -->


    <section id="The-Group-Views">
      <title>&group_views;</title>

      <para>In addition to the above views there are a number of views
      which produce the group of a referenced individual as of a
      pertinent date. These views are all named after the table from
      which they are derived, with the addition of the suffixed
      <literal>_GRP</literal>.  They are nearly identical to the table
      from which they derive, differing only by the addition of a
      column named <literal>Grp</literal>.</para>

      <para>The only operation allowed on these views is SELECT.
      INSERT, UPDATE, and DELETE are not allowed.</para>

foreach(`t', (thesetables), `make_section(t)')m4_dnl

   </section>

<!--
 Local Variables:
 mode: xml
 End:
 -->
