#    Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 2004, 2005, 2006,
# 2007, 2008, 2009, 2010 Free Software Foundation, Inc.
# 
#      Permission is granted to copy, distribute and/or modify this
#      document under the terms of the GNU Free Documentation License,
#      Version 1.3 or any later version published by the Free Software
#      Foundation; with no Invariant Sections, no Front-Cover Texts, and
#      no Back-Cover Texts.  A copy of the license is included in the
#      section entitled "GNU Free Documentation License."

# Code taken from the GNU M4 manual (24 February 2010)
# for GNU M4 (version 1.4.14), a
# package containing an implementation of the m4 macro language.

# Code modified to work with m4's -P argument.

# foreachq(x, `item_1, item_2, ..., item_n', stmt)
#   quoted list, alternate improved version
m4_define(`foreachq', `m4_ifelse(`$2', `', `',
  `m4_pushdef(`$1')_$0(`$1', `$3', `', $2)m4_popdef(`$1')')')
m4_define(`_foreachq', `m4_ifelse(`$#', `3', `',
  `m4_define(`$1', `$4')$2`'$0(`$1', `$2',
    m4_shift(m4_shift(m4_shift($@))))')')

# foreach(x, (item_1, item_2, ..., item_n), stmt)
#   parenthesized list, simple version
m4_define(`foreach', `m4_pushdef(`$1')_foreach($@)m4_popdef(`$1')')
m4_define(`_arg1', `$1')
m4_define(`_foreach', `m4_ifelse(`$2', `()', `',
  `m4_define(`$1', _arg1$2)$3`'$0(`$1', (m4_shift$2), `$3')')')

