m4_dnl Copyright (C) 2010,2011, Karl O. Pinc
m4_dnl
m4_dnl    This file is part of Babase.
m4_dnl
m4_dnl    Babase is free software; you can redistribute it and/or modify
m4_dnl    it under the terms of the GNU General Public License as published by
m4_dnl    the Free Software Foundation; either version 3 of the License, or
m4_dnl    (at your option) any later version.
m4_dnl
m4_dnl    This program is distributed in the hope that it will be useful,
m4_dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
m4_dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
m4_dnl    GNU General Public License for more details.
m4_dnl
m4_dnl    You should have received a copy of the GNU General Public License
m4_dnl    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
m4_dnl
m4_dnl Karl O. Pinc <kop@meme.com>
m4_dnl
m4_dnl
m4_dnl m4 macro file for making TESTES_foo testes documentation.
m4_dnl
m4_dnl Input:
m4_dnl                  (in lower case)
m4_dnl
m4_define(`TESTES_SUFFIX', m4_translit(testes_suffix, a-z, A-z))m4_dnl
<?xml version='1.0'?>
<!DOCTYPE para PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
         "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
         [
          <!ENTITY  plusmn  "&#x00B1;"> <!-- recommended in case external
                                             entity not available -->

          <!-- Use symbols for hardcoded Babase data -->
          <!ENTITY  % constants SYSTEM "../constants">
          %constants;
]>
<!-- Copyright (C) 2010, 2011 Karl O. Pinc <kop@meme.com> and others
   - See document output for full copyright information. -->

<!-- DO NOT EDIT THIS FILE.  It was automatically generated.  Edit
   - the testes_stats.xml.m4 file instead.  (Files _should_ be re-created by
   - typing 'make' at the command line.) -->

<!-- Core documentation on the TESTES_STATS view.

   - This is indeed the query that makes the view, so don't break it!

   - The "code" element must have a 'role="view"' attribute
   - so that Babase code generation can get the code
   - and actually make the view!
-->

<para>
<figure id="testes_`'testes_suffix`'_stats-code">
  <title>Query Defining the TESTES_`'TESTES_SUFFIX`'_STATS View</title>
  <literallayout>
<code role="view">SELECT testesdartids.dartid AS dartid
     , testesllength.testllengthsamps AS testllengthsamps
     , testesllength.testllength_mean AS testllength_mean
     , testesllength.testllength_stddev AS testllength_stddev
     , testeslwidth.testlwidthsamps AS testlwidthsamps
     , testeslwidth.testlwidth_mean AS testlwidth_mean
     , testeslwidth.testlwidth_stddev AS testlwidth_stddev
     , testesrlength.testrlengthsamps AS testrlengthsamps
     , testesrlength.testrlength_mean AS testrlength_mean
     , testesrlength.testrlength_stddev AS testrlength_stddev
     , testesrwidth.testrwidthsamps AS testrwidthsamps
     , testesrwidth.testrwidth_mean AS testrwidth_mean
     , testesrwidth.testrwidth_stddev AS testrwidth_stddev
FROM (SELECT testes_`'testes_suffix.dartid
        FROM testes_`'testes_suffix
        GROUP BY testes_`'testes_suffix.dartid)
       AS testesdartids
     LEFT OUTER JOIN
       (SELECT testes_`'testes_suffix.dartid AS llengthdartid
             , count(*) AS testllengthsamps
             , avg(testes_`'testes_suffix.testlength) AS testllength_mean
             , stddev(testes_`'testes_suffix.testlength) AS testllength_stddev
          FROM testes_`'testes_suffix
          WHERE testes_`'testes_suffix.testside = '&bb_lefttestes;'
                AND testes_`'testes_suffix.testlength IS NOT NULL
          GROUP BY testes_`'testes_suffix.dartid)
         AS testesllength
       ON testesllength.llengthdartid = testesdartids.dartid
     LEFT OUTER JOIN
       (SELECT testes_`'testes_suffix.dartid AS lwidthdartid
             , count(*) AS testlwidthsamps
             , avg(testes_`'testes_suffix.testwidth) AS testlwidth_mean
             , stddev(testes_`'testes_suffix.testwidth) AS testlwidth_stddev
          FROM testes_`'testes_suffix
          WHERE testes_`'testes_suffix.testside = '&bb_lefttestes;'
                AND testes_`'testes_suffix.testwidth IS NOT NULL
          GROUP BY testes_`'testes_suffix.dartid)
         AS testeslwidth
       ON testeslwidth.lwidthdartid = testesdartids.dartid
     LEFT OUTER JOIN
       (SELECT testes_`'testes_suffix.dartid AS rlengthdartid
             , count(*) AS testrlengthsamps
             , avg(testes_`'testes_suffix.testlength) AS testrlength_mean
             , stddev(testes_`'testes_suffix.testlength) AS testrlength_stddev
          FROM testes_`'testes_suffix
          WHERE testes_`'testes_suffix.testside = '&bb_righttestes;'
                AND testes_`'testes_suffix.testlength IS NOT NULL
          GROUP BY testes_`'testes_suffix.dartid)
         AS testesrlength
       ON testesrlength.rlengthdartid = testesdartids.dartid
     LEFT OUTER JOIN
       (SELECT testes_`'testes_suffix.dartid AS rwidthdartid
             , count(*) AS testrwidthsamps
             , avg(testes_`'testes_suffix.testwidth) AS testrwidth_mean
             , stddev(testes_`'testes_suffix.testwidth) AS testrwidth_stddev
          FROM testes_`'testes_suffix
          WHERE testes_`'testes_suffix.testside = '&bb_righttestes;'
                AND testes_`'testes_suffix.testwidth IS NOT NULL
          GROUP BY testes_`'testes_suffix.dartid)
         AS testesrwidth
       ON testesrwidth.rwidthdartid = testesdartids.dartid</code><code>;</code></literallayout>
  </figure>

<!-- Figure containing TESTES_`'TESTES_SUFFIX`'_STATS view diagram. -->

<!-- Use mediaobject role attribute to select either xhtml (html)
     or pdf (fo) file paths.  -->

  <figure id="testes_`'testes_suffix`'_stats-erd">
      <title>Entity Relationship Diagram of the
      TESTES_`'TESTES_SUFFIX`'_STATS View</title>
      <mediaobject>
        <imageobject role="html">
          <imagedata scalefit="1" width="6in"
            fileref="/diagrams/testes_`'testes_suffix`'_stats.png"
            format="PNG" />
        </imageobject>
        <imageobject role="dblatex">
          <imagedata scalefit="1" width="6in"
            fileref="/diagrams/testes_`'testes_suffix`'_stats.png"
            format="PNG" />
        </imageobject>

        <textobject> <phrase>If we could we would display here the
           diagram showing how the TESTES_`'TESTES_SUFFIX`'_STATS view
           is constructed.</phrase>
        </textobject>
      </mediaobject>
    </figure>
</para>
<!--
 Local Variables:
 mode: xml
 End:
 -->
