# Copyright (C) 2016 Jake Gordon, <jacob.gordon@duke.edu>
# Copyright (C) 2011, 2012 The Meme Factory, Inc.  http://www.meme.com/
# Copyright (C) 2010, 2011 Karl O. Pinc <kop@meme.com>
#
#    This file is part of Babase.
#
#    Babase is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
#
# Define the different views that exist.
#
# Karl O. Pinc <kop@meme.com>
#
# Note that we can't do this with a wildcard because some of the views
# are generated.

# These are the generated "group" views.
GROUP_VIEWS := birth_grp entrydate_grp statdate_grp \
             consortdates_grp cycgapdays_grp cycgaps_grp \
             cycstats_grp dartings_grp dispersedates_grp maturedates_grp \
             mdintervals_grp mmintervals_grp pcskins_grp rankdates_grp \
             repstats_grp

# This is a kludge, a repeat of the generated group views, but when
# the table name from which the view is genereated is different from
# the view name (with the trailing _grp) removed, then add
# in the table name.
TABLEGROUP_VIEWS := biograph/birth_grp biograph/entrydate_grp \
             biograph/statdate_grp \
             consortdates_grp cycgapdays_grp cycgaps_grp \
             cycstats_grp dartings_grp dispersedates_grp maturedates_grp \
             mdintervals_grp mmintervals_grp pcskins_grp rankdates_grp \
             repstats_grp

# These are generated and should be ignored by darcs.
# We sometimes need to know which these are so that we can generate them
# if they are not there.
M4_VIEWS := $(GROUP_VIEWS) \
           testes_arc_stats testes_diam_stats

# Sexskins and neighbors need a group.

# Order is significant here, views are created in this order.
# This supports views that use other views.
VIEW_NAMES := $(M4_VIEWS) \
             maternities census_demog cycpoints_cycles cycles_sexskins \
             pcskins_sorted interact points actor_actees \
             mtd_cycles points_sorted census_demog_sorted \
             cycpoints_cycles_sorted interact_sorted cycles_sexskins_sorted \
             demog_census demog_census_sorted \
             sexskins_cycles sexskins_cycles_sorted \
             mpi_events min_maxs min_maxs_sorted crownrump_stats \
             anesth_stats chest_stats ulna_stats humerus_stats dsamples \
             pcv_stats bodytemp_stats dent_codes dent_sites \
             potential_dads parents swerb_departs quads swerb swerb_data_xy \
             swerb_gw_loc_data_xy swerb_gw_locs swerb_upload swerb_locs \
             swerb_loc_gps_xy samples_goff \
             groups_history
