<?php
/* Copyright (C) 2012 The Meme Factory, Inc.  http://www.meme.com/
 * Copyright (C) 2006, 2008, Karl O. Pinc  <kop@meme.com>
 *
 *    This file is part of Babase.
 *
 *    Babase is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Logout from the babase web programs.
 *
 * Karl O. Pinc <kop@meme.com>
 */

// Includes
require('constants.php.inc');
require('lib_upload.php.inc');

//
// Constants
//

// $action values
define('ACTION_LOGOUT', 'out');

//
// Functions.
// 

//
// Body of code
//

maintain_login_session();

//
// Get the form data.
//

// $action
// What page we're in.
if (array_key_exists('action', $_REQUEST)) {
  $action = $_REQUEST['action'];
} else {
  $action = ACTION_NONE;
}

// $db
if (array_key_exists('db', $_REQUEST)) {
  $db = htmlentities(trim($_REQUEST['db']), ENT_QUOTES);
  $_SESSION['db'] = $db;
} else {
  if (array_key_exists('db', $_SESSION)) {
    $db = $_SESSION['db'];
  } else {
    $db = '';
  }
}

// $user
if (array_key_exists('user', $_REQUEST)) {
  $user = htmlentities(trim($_REQUEST['user']), ENT_QUOTES);
  $_SESSION['user'] = $user;
} else {
  if (array_key_exists('user', $_SESSION)) {
    $user = $_SESSION['user'];
  } else {
    $user = '';
  }
}

// $password
if (array_key_exists('password', $_REQUEST)) {
  $password = $_REQUEST['password'];
  $_SESSION['password'] = password;
} else {
  if (array_key_exists('password', $_SESSION)) {
    $password = $_SESSION['password'];
  } else {
    $password = '';
  }
}

//
// Logout before any output so we can clear the cookie.
//

if ($action == ACTION_LOGOUT) {

  // Unset all of the session variables.
  $_SESSION = array();

  // Kill the session, also delete the session cookie.
  // Note: This will destroy the session, and not just the session data!
  if (isset($_COOKIE[session_name()])) {
    setcookie(session_name(), '', time()-42000);
  }

  // Finally, destroy the session.
  session_destroy();
}

?><?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <title>Logout -- Logout From The Custom Babase Programs</title>
    <link rel="stylesheet" href="/babase.css" type="text/css" />
  </head>
  <body>

<p class="navbar">
<a href="<?php print HOME_TARGET; ?>">HOME</a>
</p>

<h1>Logout From The Custom Babase Programs</h1>

<?php
//
// Process input values
//

if ($user == '' || $action == ACTION_LOGOUT) {
  print '<div class="status"><p class="success">You are logged out.</p></div>';
} else {
  ?>
  
  <form action="" enctype="multipart/form-data" method="post">
    <div>
     <input name="action"
            type="hidden"
            value="<?php print ACTION_LOGOUT; ?>"
            />
     </div>

  <table>
      <tr>
        <td class="label">
          Current database:
        </td>
        <td>
          <?php print $db; ?>
        </td>
      </tr>
      <tr>
        <td class="label">
          Current user:
        </td>
        <td>
          <?php print $user; ?>
        </td>
      </tr>
  </table>
  
  <p>
  <input value="Logout" tabindex="20" type="submit" />
  </p>
  </form>

  <?php
}
// Finish the stock page.
?>

<p class="navbar">
<a href="<?php print HOME_TARGET; ?>">HOME</a>
</p>

</body>
</html>
