<?php
/* Copyright (C) 2014, The Meme Factory, Inc.  http://www.meme.com/
 * Copyright (C) 2006, 2007, 2008, 2010, Karl O. Pinc <kop@meme.com>
 *
 *    This file is part of Babase.
 *
 *    Babase is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Constants for Babase PHP programs.
 *
 * Karl O. Pinc <kop@meme.com>
 *
 * Remarks:
 *  Constants that appear in the m4 files for use in triggers have
 *  the same name here, except uppercase.
 */

// Constants
if (!defined('_BABASE_CONSTANTS')) {
  define('_BABASE_CONSTANTS', '');

  // Postgresql server related.
  define('HOME_TARGET', '/babasewiki/ProgramLinks');
  define('PROGRAM_BASE', '/programs/');
  define('PG_HOST', 'localhost');

  // SQL related.
  define('SQL_NULL', 'NULL');

  // Samples table.

  // Types for samples.stype.
  define('BB_JUVENILE_POINT', 'J');
  define('BB_FEMALE_POINT', 'F');

  // Data_Structures table.

  // Values for setupids.data_structure.
  define('BB_KNOWN_DATA_STRUCTURE', '1');

  // Parts and MPI_Parts tables.
  define('BB_ACTOR', 'R');
  define('BB_ACTEE', 'E');

  // Points table.

  // Neighbors values
  // (These are actually in the database, and so in
  // this file however, there are no corresponding 
  // m4 constants because the triggers don't care.)
  define('PSION_NEIGHBOR1', '1');
  define('PSION_NEIGHBOR2_JUV', '2');
  define('PSION_NEIGHBOR3_JUV', '3');
  define('PSION_NEIGHBOR2_FEM', 'A');
  define('PSION_NEIGHBOR3_FEM', 'O');

  // Unidentified Sname for ADL interactions.
  define('UNIDENTIFIED_SNAME', '998');
}
