# TODO: only works with Python 2
# nix-shell -p darcs pythonPackages.fabric
import time

from fabric.api import task, run, env, local, put
from fabric.contrib.console import confirm
from fabric.contrib.files import upload_template
from fabric.operations import prompt


env.user = 'domen'
env.hosts = ['abrp-genomics.biology.duke.edu']


@task
def deploy_test():
    # TODO: check for local modifications

    # run tests
    local('py.test')

    if not confirm('Did you darcs record everything?'):
        return

    # bump version
    local('grep version setup.py')
    version = prompt('Bump version to:')
    local("sed -i \"s/version='.*'/version='{version}'/\" setup.py".format(version=version))
    local('darcs record -a -m "bump version" setup.py')

    # push changes
    local('darcs push -a domen@abrp-genomics.biology.duke.edu:babase_share/babase_domen_clean')

    # copy/generate static react.js
    local('./node_modules/.bin/jsx -x jsx csvdump/static/js/ csvdump/static/js')
    put('csvdump/static/js/components.js', '/var/www/testsite/static/js/components.js')

    # pip install stuff
    # TODO: rather install .tar.gz file
    run('/srv/virtualenv/funcgendump_test/bin/pip install /home/domen/babase_share/babase_domen_clean/www/pyramid/CSVDump/')

    # copy uwsgi file
    # TODO: doesn't work due to file permissions
    #upload_template(
    #    'funcgendump_test.ini',
    #    '/usr/local/etc/uwsgi.d/funcgendump_test.ini',
    #)

    # touch uwsgi to reload
    run('touch /usr/local/etc/uwsgi.d/funcgendump_test.ini')

    # check with curl
    time.sleep(5)
    run('curl http://abrp-genomics-vpn.biology.duke.edu/functional-genomic-download/')
