## Copyright (C) 2015 The Meme Factory, Inc.  http://www.meme.com/
##
##    This file is part of Babase.
##
##    Babase is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 3 of the License, or
##    (at your option) any later version.
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
##
## Karl O. Pinc <kop@meme.com>
<!DOCTYPE html>
<html lang="${request.locale_name}">
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="${meta_description}" />
##    <link rel="shortcut icon" href="${request.static_url('vcfdump:static/pyramid-16x16.png')}" />

    <title>ABRP Genomics VCF Downloads</title>

    <!-- Bootstrap core CSS -->
    <link
      href="${request.static_url('vcfdump:static/css/bootstrap.css')}"
      rel="stylesheet" media="screen" />
    <link rel="stylesheet"
     href="${request.static_url('vcfdump:static/css/bootswatch.min.css')}" />

    ## Custom styles go here (after Bootstrap)
    <link href="${request.static_url('vcfdump:static/css/wiki.css')}"
          rel="stylesheet" />

    <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="${request.static_url('vcfdump:static/js/html5shiv.js')}"></script>
      <script src="${request.static_url('vcfdump:static/js/respond.js')}"></script>
    <![endif]-->
  </head>

  <body>
    <div class="container-fluid">
      <div class="row">
        <div class="col-sm-3 col-md-2 sidebar">
          <div class="nav nav-sidebar logo-div">
            <img class="logo-image"
               src="http://abrp-genomics.biology.duke.edu/abrp-genomics-logo.png"
               alt="ABRP Logo">
          </div>

          <div class="nav nav-sidebar nav-indent">
              <a href="/"
                 title="The ABRP Genomics Home Page">ABRP Genomics Home</a>
          </div>
        </div>

        <div class="main col-sm-9 col-md-10">
	  <div class="row nav navbar-nav navbar-right">
            <a href="https://abrp-genomics.biology.duke.edu/index.php?title=Download_Help#ABRP_Genomics_VCF_Downloads">
              Help
            </a>
          </div>


          ${self.body()}


	  <footer>
	   <div class="row">
	    <div class="col-lg-12">
	     <ul class="list-unstyled">
	      <li class="pull-right">
	       <a href="#top">
		Back to top
	       </a>
	      </li>
	      <li>
	       <a href="https://abrp-genomics.biology.duke.edu/index.php?title=Download_Help#ABRP_Genomics_VCF_Downloads">
		Help
	       </a>
	      </li>
	     </ul>
	    </div>
	   </div>
	   <hr />
	   <div class="row">
	    <div class="col-lg-12">
       <h4>Terms of Use</h4>
       <p>
       Data from the ABRP Genomics Public Portal are freely available for
       use. Please 
       <a href="https://abrp-genomics.biology.duke.edu/index.php?title=Download_Help#Study_Descriptions"
       target="_blank">cite</a> the studies responsible for producing the
       data if you use them in a publication or web page.  The software
       delivering this web page and all software developed to support the
       Amboseli Baboon Research Project is licensed as Free and Open Source
       Software. Anyone
       may <a href="http://papio.biology.duke.edu/babasewiki/SourceCode"
       target="_blank">download</a> and use the software.
       </p>
       <h4>Acknowledgments</h4>
       <p>
       We gratefully acknowledge the support of the National Institute on
       Aging (R03 AG045459 and R21 AG049936 to J. Tung and S. C. Alberts) for
       supporting the development of the ABRP Genomics Public Portal and
       underlying database design. We also thank <a href="http://meme.com/"
       target="_blank">Karl Pinc</a>, <a href="http://www.stevepiercy.com/"
       target="_blank">Steve Piercy</a>,
       and <a href="https://www.domenkozar.com/" target="_blank">Domen
       Kožar</a> for assistance with database programming and website
       development, and the <a href="http://gmod.org/wiki/Main_Page"
       target="_blank">Generic Model Organism Database</a> project for
       development and support of the <a href="http://gmod.org/wiki/Chado"
       target="_blank">Chado</a> relational database schema.
       </p>
	    </div>
	   </div>
	  </footer>

        </div>
      </div>
    </div>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="${request.static_url('vcfdump:static/js/jquery-1.10.2.min.js')}"></script>
    <script src="${request.static_url('vcfdump:static/js/bootstrap.js')}"></script>
    <script src="${request.static_url('vcfdump:static/js/bootswatch.js')}"></script>
    <script src="${request.static_url('vcfdump:static/js/vcfdump.js')}"></script>
  </body>
</html>
