## Copyright (C) 2015 The Meme Factory, Inc.  http://www.meme.com/
##
##    This file is part of Babase.
##
##    Babase is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 3 of the License, or
##    (at your option) any later version.
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with Babase.  If not, see <http://www.gnu.org/licenses/>.
##
## Karl O. Pinc <kop@meme.com>
<%!
    import markupsafe
    from vcfdump.lib.constants import CONTENT_TYPE
    from vcfdump.lib.functions import build_filename
%>

<%inherit file="base.mako"/>

<h1>Available VCF Files</h1>

% if vcf_files:
  <table class="table table-condensed table-hover">
    <thead>
      <tr>
        <th></th>
        <th>Name</th>
        <th>Description</th>
        <th>Size<br/>(uncompressed)</th>
      </tr>
    </thead>
    <tbody class="table-striped clickable-data">
      % for vcf_file in vcf_files:
        <%
          rowid = 'tr_{0}'.format(vcf_file['id'])
          target = 'vcfdl?id={0}'.format(vcf_file['id'])
          filename = markupsafe.escape(build_filename(vcf_file['name']))
        %>
        <tr id="${rowid}" data-url="${target}" title="Download ${filename}">
          <td>
            <a href="#${rowid}" class="permalink"
               title="Permanent link to ${vcf_file['name']}">
              <span class="glyphicon glyphicon-link" aria-hidden="true"></span>
            </a>
	  </td>
	  <td>
            <a href="${target}"
                 class="btn btn-link permalink"
                 role="button"
                 type="${CONTENT_TYPE}"
                 download="${filename}"
                 target="_blank"
                 data-filename="${filename}"
                 data-toggle="model"
                 data-target="#dlModel"
              >${vcf_file['name'] | h}</a></td>
          <td>${vcf_file['description'] | h}</td>
          <td>${vcf_file['size'] | h}</td>
        </tr>
      % endfor
    </tbody>
  </table>
% else:
  <p>There are no files available for download at this time.
     Please try again later.</p>
% endif
