#!/bin/sh
# Copyright (C) 2015 The Meme Factory, Inc.  http://www.meme.com/
#
#   This file is part of Babase.
#
#   Babase is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with Babase.  If not, see <http://www.gnu.org/licenses/>.
#
# Karl O. Pinc <kop@meme.com>
#
# Syntax: abrp-genomics-update-testdir
#
# Input:
#
# Remarks:
#   See docbooks docs for more info.
#
# Bugs:
#
divert(-1)dnl
dnl m4 macro definitions

include(`macros.m4')
include(`constants.m4')

divert`'dnl
editwarning()

export BASE=bb_mnt_abrp_genomics
export TESTDIR=$BASE/test
export DIRNAMES="vcf funcgen stock"

# Remove old symlinks
find $TESTDIR -type l -exec rm {} \;

# Make new symlinks
for d in $DIRNAMES ; do
  for f in $(ls $BASE/$d) ; do
     ln -s "../../$d/$f" "$TESTDIR/$d/$f"
  done
done

logger -t "$(basename $0)" -p bb_syslog_facility.INFO \
       "Updated symlinks in $TESTDIR hierarchy"
